import * as globalMethods from 'quest-global';
import { element, by, browser, ExpectedConditions } from 'protractor';
import * as fs from 'fs';
import { Common } from '../support/common';

var axios = require('axios');
let dataFile;
//let url = "http://auth-gateway-dev.mq.questdiagnostics.com:8080/mq-service/";
process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';
let securityHeaders = {
    'X-CSRF-TOKEN': '123',
    'Content-Type': 'application/json',
    'Cookie': 'CSRF-TOKEN=123',
};


export class CheckCovidEligibility {    
    /**
     * gets the reponse checkRosterEligibility by the testdata(request body) provided and api end point
     * @param dataFile
     * @param apiEndpoint
     */
    async checkCovidEligibility(data1){
        let rosterResponseFirstName;
        let rosterResponseCovidPartnerEligibilityId;
        let rosterResponseEligible;
        let rosterEligibiltyCriteria =[];
        var axios = require('axios');
        let domain = await browser.getProcessedConfig();
        domain = "https://" + await domain.environment + ".mq.questdiagnostics.com/";
        let url = await domain + await "guest/checkCovidEligibility";
        await globalMethods.log("Employee Last Name: " + await data1.empLastName + ", id: " + await data1.empID + ", DOB: " + await data1.dateOfBirth);
        let data = {
            "programId": await data1.programId,
            "empLastName": await data1.empLastName,
            "partnerEmployeeId": await data1.empID,
            "dateOfBirth": await data1.dateOfBirth,
            "prsId": "string",
            "hipaaAccepted": true
        };
        var config = { 
            headers: securityHeaders
        };
        await globalMethods.log("URL: " + url);
        await console.log("config: "+JSON.stringify(config));
        await globalMethods.log("payload :" +JSON.stringify(data));

        try {
            let response = await axios.post(url, data, config);
            let statusCode = await response.status;
            await globalMethods.log("Status Code:" + await statusCode);
            await globalMethods.log("Response Body" + await JSON.stringify(response.data.data));
            rosterResponseFirstName=await response.data.data.firstName;
            rosterResponseCovidPartnerEligibilityId=await response.data.data.covidPartnerEligibilityId;
            rosterResponseEligible=await response.data.data.eligible;

            await rosterEligibiltyCriteria.push(rosterResponseFirstName);
            await rosterEligibiltyCriteria.push(rosterResponseCovidPartnerEligibilityId);
            await rosterEligibiltyCriteria.push(rosterResponseEligible);

            return await rosterEligibiltyCriteria;
        }
        catch(error){
            await globalMethods.log("Error: Status Code:" + await error.response.status + ", data:" + JSON.stringify(error.response.data));
            
        }

    }
    /**
     * Verifies Roster member eligibility true/false
     * @param responseEligibilityData
     */
    async verifyRosterMemberEligibility(rosterEligibilityCriteria){
        let responseFirstName = await rosterEligibilityCriteria[0];
        let responseEligibilityId = await rosterEligibilityCriteria[1];
        let responseEligibility = await rosterEligibilityCriteria[2].toString();
        if(Common.data.eligible == "false") Common.data.empfirstName=Common.data.covidPartnerEligibilityId=null;
        await globalMethods.verifyFailOnError(
            responseEligibility,
            Common.data.eligible,
            "Expected eligibility:" + Common.data.eligible + ", actual eligibility:" + responseEligibility,
            true
        );
        await globalMethods.verifyFailOnError(
            responseFirstName,
            Common.data.empfirstName,
            "Expected first name:" + Common.data.empfirstName + ", actual first name:" + responseFirstName,
            true
        );
        await globalMethods.verifyFailOnError(
            responseEligibilityId,
            Common.data.covidPartnerEligibilityId,
            "Expected id:" + Common.data.covidPartnerEligibilityId + ", actual id:" + responseEligibilityId,
            true
        );
    }

}