const jsonTmpDirectory = './e2e/reports/results/';
const currentTime = new Date().toJSON().replace(/:/g, "-");
const fs = require('fs');
const reporter = require('cucumber-html-reporter');
const { removeSync } = require('fs-extra');
const globalMethods = require('quest-global');
const generateReport = require('../../reporter');

exports.config = {
  directConnect: true,
  seleniumAddress: 'http://localhost:4444/wd/hub',

  capabilities: {
    'browserName': 'chrome',
    chromeOptions: {
      args: ["--headless","--window-size-800x600", "--no-sandbox"]
    },
  },

  environment: 'QA',
  dataUrl: 'http://localhost:3000/GSS/api',
  framework: 'custom',
  specs: [
    '../features/**/HealthCustomerService.feature'
  ],

  frameworkPath: require.resolve('protractor-cucumber-framework'),
  cucumberOpts: {
    compiler: 'ts:ts-node/register',    // <string[]> ("extension:module") require files with the given EXTENSION after requiring MODULE (repeatable)
    require: ['../**/*.ts', '../support/hooks.ts'],  // require step definition files before executing features
    tags: ['@P1','@HCS'],                           // <string[]> (expression) only execute the features or scenarios with tags matching the expression
    strict: true,                       // <boolean> fail if there are any undefined or pending steps
    'dry-run': false,
    'backtrace': true,                  // <boolean> invoke formatters without executing steps
    format: 'json:e2e/reports/results/results.json'
  },
  ignoreUncaughtExceptions: true,
  jasmineNodeOpts: {
    showColors: true,
    defaultTimeoutInterval: 30000,
    print: function () { }
  },
  onPrepare() {
    require('ts-node').register({
      project: 'e2e/tsconfig.e2e.json'
    });
  },
  onComplete: async function (exitCode, config, capabilities, results) {
    try {
      await generateReport();
      await globalMethods.log(process.toString());
    } catch (err) {
      console.log('err', err);
    }

  }
};
