import * as questglobal from 'quest-global';
import { by, element, browser, protractor, ExpectedConditions } from 'protractor';
import * as globalMethods from 'quest-global';
import '../global/global';

let timeout=9500;
var global = require('../global/global');
let MyQuestHomePageText = '/home';
let CreateAccountPageText = '/create-account';

export class CreateAccount {

getUserName() {
      //   using this locator because there is no better locator but using below locator is not a good practice. Will replace this with good locator (probably an id or data-ta) when dev team provides one
      //return quest-global.getElementByXpath("//input[contains(@id,'mat-input')]");
      return globalMethods.getElementByXpath("//input[@formcontrolname='username']");
  }
getUserNameErrorMsg() {
    //   using this locator because there is no better locator but using below locator is not a good practice. Will replace this with good locator (probably an id or data-ta) when dev team provides one
    return questglobal.getElementByXpath("//input[contains(@id,'mat-input')]/../../..//mat-error");
}
getPassword() {
      //   using this locator because there is no better locator but using below locator is not a good practice. Will replace this with good locator (probably an id or data-ta) when dev team provides one
    //return questglobal.getElementByXpath("//input[@id='mat-input-2']");
    return globalMethods.getElementByXpath("//input[@formcontrolname='password']");
}
getRetypePassword() {
    //   using this locator because there is no better locator but using below locator is not a good practice. Will replace this with good locator (probably an id or data-ta) when dev team provides one
    //return questglobal.getElementByXpath("//input[@id='mat-input-3']");
    return globalMethods.getElementByXpath("//input[@formcontrolname='rePassword']")
}
getCreateAccount(){
    return element(by.id('skip-to-main'));
 }
getClose(){
    return element(by.xpath("//mat-icon[@class='qd-icon icon-close material-icons mat-icon']"));
 }
getAppleHelathBanner(){
    return element(by.xpath("//div[@class='pl-marketing-banner']"));
 }
 getLearnMore(){
    return element(by.xpath("//button[@class='pl-marketing-banner__button']"));
 }
 getAppleHelathBannerText(){
    return element(by.xpath("//div[@class='pl-marketing-banner__copy']"));
 }
 getPopUpWindowHeader(){
    return element(by.xpath("//div[@class='pl-marketing-dialog__header']"));
 }
 getOkay(){
    return element(by.xpath("//button[@type='button']"));
 }
 getPopUpWindowText(){
    return element(by.xpath("//p[@class='pl-marketing-dialog__copy']"));
 }
 getRecoverButton(){
   return globalMethods.getElementByXpath("//button[@class='qd-button Recover-button mat-button']");
}
getDuplicateAccountWarningTitle(){
   return globalMethods.getElementByXpath("//div[@class='qd-dialog-title']");
}
getContinueAsNewPatient() {
   return globalMethods.getElementByXpath("//div[@class='cancelRecover']/div/a");
   //a[@class='qd-link']");
}
getRecoverText() {
   return globalMethods.getElementByXpath("//div[@class='recover-bold']");
}
getArrowForward() {
   return globalMethods.getElementByXpath("//mat-icon[contains(text(), 'arrow_forward')]");
}
getEmailAddresses() {
   return globalMethods.getElementByXpath("//p[@class='emailfield']");
}

getCreateAccountNextButton() {
   return globalMethods.getElementByXpath("//button/span[contains(text(),'Next')]");
}
getCreateAccountFirstName() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='firstName']")
}
getCreateAccountLastName() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='lastName']");
}
getCreateAccountDOB() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='dateOfBirth']");
}
getCreateAccountSex() {
   //return globalMethods.getElementByXpath("//mat-select[@formcontrolname='sex']");
   return globalMethods.getElementByXpath("//mat-select[@aria-label='Sex']");
   //mat-select[@aria-label='Sex']/div/div/span/span
}
getCreateAccountPrimaryPhoneNo() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='primaryPhone']");
}
getCreateAccountEmail() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='email']");
}
getCreateAccountReEnterEmail() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='reEmail']");
}
getCreateAccountStreetAddress() {
   return globalMethods.getElementByXpath("//input[@id='as_ContactAddress_txt']");
}
getCreateAccountCity() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='city']");
}
getCreateAccountState() {
   return globalMethods.getElementById('as_State_txt');
}
getCreateAccountZip() {
   return globalMethods.getElementByXpath("//input[@formcontrolname='zipCode']");
}
getRecoverEmailAddress() {
   return globalMethods.getElementByXpath("//div[@class='qd-form-field qd-input email-wrapper']/p");
}
getRecoverThankYouText() {
   return globalMethods.getElementByXpath("//div[@class='recover-bold']");
}
getRecoverBackToLogin() {
   //return globalMethods.getElementByXpath("//a[@class='qd-link']");
   return globalMethods.getElementByXpath("//a[contains(text(),'BACK TO LOGIN')]");
}
getOpenCalendar() {
   return globalMethods.getElementByXpath("//button[@aria-label='Open calendar']");
}
getTermsAndConditionsLink() { 
   return globalMethods.getElementByXpath("//div[@class='toggle']");
}
getTextDescription() {
   return globalMethods.getElementByXpath("//div[@class='qd-blockquote']");
}


//  Setters
/**
 * clickCreateAccount method clicks on 'Create Account' button of MyQuest Home Page.
 */
async clickCreateAccount(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getCreateAccount(), 'Create Account', timeout);
    await browser.waitForAngularEnabled(true);
}
async clickLearnMore(): Promise<void>{
   await globalMethods.click(await this.getLearnMore(), 'Learn More', timeout);
}
async clickOkay(): Promise<void>{
   await globalMethods.click(await this.getOkay(), 'Okay', timeout);
}
/**
 * clickClose method clicks on close button of create account page.
 */
async clickClose(): Promise<void>{
   await browser.waitForAngularEnabled(false);
   await globalMethods.waitForElement(await this.getClose(), true, timeout);
   await globalMethods.click(await this.getClose(), 'Close', timeout);
   await browser.waitForAngularEnabled(true);
}
async clickNext(): Promise <void>{
   //await browser.wait(ExpectedConditions.elementToBeClickable(await this.getCreateAccountNextButton()), timeout);
   await browser.waitForAngularEnabled(false);
   await globalMethods.waitForClickable(await this.getCreateAccountNextButton(), timeout);
   var NextButtonStatus = await this.getCreateAccountNextButton().isEnabled();
   await globalMethods.log("Next Button Status Enabled: "+NextButtonStatus);
   // Adding sleep time here bcos, it takes few seconds to get enabled. In step 2 of create account flow, even though it says the next button state is enabled, upon click of nex not navigated to duplicate account warning screen.
   await browser.sleep(5000);
      await browser.executeScript('arguments[0].click();', await this.getCreateAccountNextButton());   
      await browser.waitForAngularEnabled(true);
}
async clickRecover(): Promise<void>{
   //await browser.wait(ExpectedConditions.elementToBeClickable(await this.getRecoverButton()), timeout);
   await globalMethods.waitForClickable(await this.getRecoverButton(), timeout);
   var RecoverButtonStatus = await this.getRecoverButton().isEnabled();
   await globalMethods.log("Recover Button Status Enabled: "+RecoverButtonStatus);
   await browser.executeScript('arguments[0].click();', await this.getRecoverButton());   
}
async clickRecoverBackToLogin(): Promise<void> {  
   await globalMethods.log("Clicking on Back To Login link");
   await browser.executeScript('arguments[0].click();', await this.getRecoverBackToLogin());
}
async clickcontinueAsNewPatient(): Promise<void> {
   await globalMethods.log("Clicking on Continue as New Patient link");
   await browser.executeScript('arguments[0].click();', await this.getContinueAsNewPatient());
}
async clickDateOfBirth(): Promise<void> {
   await globalMethods.log("Clicking Date OF Birth");
   await globalMethods.click(await this.getCreateAccountDOB(), 'Date Of Birth', timeout);
}
async clickCreateAccountFirstName(): Promise <void> {
   await globalMethods.click(await this.getCreateAccountFirstName(), 'First Name', timeout);
}

/**
 * procedureEnterDataOnCreateAccount method enters username, password and retypepassword data on create account page.
 * @param userName 
 * @param password 
 * @param retypePassword 
 */
async procedureEnterDataOnCreateAccount(userName, password, retypePassword){   
   await browser.waitForAngularEnabled(false);
   await globalMethods.log("Entering data in Create Account page");
   await globalMethods.waitForElement(await this.getUserName(),true,timeout);
   globalMethods.waitForVisible(await this.getUserName(),timeout);
   await browser.driver.findElement(by.xpath("//input[contains(@id,'mat-input')]")).sendKeys(userName);
   //await this.getUserName().sendKeys(userName);
   await this.getPassword().sendKeys(password);
   await this.getRetypePassword().sendKeys(retypePassword);
   await browser.waitForAngularEnabled(true);
}
async procedureEnterDataOnTellUsMoreAboutYou(firstName, lastName, dob) {   
   await browser.waitForAngularEnabled(false);
   await globalMethods.waitForElement(await this.getCreateAccountFirstName(),true,timeout);
   await globalMethods.waitForVisible(await this.getCreateAccountFirstName(),timeout);
   await this.getCreateAccountFirstName().sendKeys(firstName);
   await globalMethods.sendKeys(await this.getCreateAccountFirstName(), protractor.Key.TAB, timeout, false);  
   await this.getCreateAccountLastName().sendKeys(lastName);
   await globalMethods.waitForElement(await this.getOpenCalendar(), true, timeout);
   await this.clickDateOfBirth();
   await globalMethods.log("Pressing Escape");
   await this.getCreateAccountDOB().sendKeys(protractor.Key.ESCAPE);   
   await globalMethods.sendText(await this.getCreateAccountDOB(), await dob, timeout);   
   var genderstatus = await this.getCreateAccountSex().isPresent();
   await globalMethods.log("Verifying the presence of gender drop down"+ genderstatus);
   await global.selectFromDropDown(await this.getCreateAccountSex(), 'Female', timeout);
   await browser.waitForAngularEnabled(true);
}
async procedureEnterDataOnHowToStayInTouchWithYou(primaryPhone, email, reenterEmail, streetAddress, zip, city, state) {   
   await browser.waitForAngularEnabled(false);
   await globalMethods.waitForElement(await this.getCreateAccountPrimaryPhoneNo(),true,timeout);
   await globalMethods.waitForVisible(await this.getCreateAccountPrimaryPhoneNo(),timeout);
   await this.getCreateAccountPrimaryPhoneNo().sendKeys(primaryPhone);   
   await this.getCreateAccountEmail().sendKeys(email);
   await this.getCreateAccountReEnterEmail().sendKeys(reenterEmail);
   await this.getCreateAccountStreetAddress().sendKeys(streetAddress);
   await browser.sleep(1000);
   await this.getCreateAccountStreetAddress().sendKeys(protractor.Key.ESCAPE);
   //await global.enterAndSelectFromAutoSuggest(await this.getCreateAccountStreetAddress(), streetAddress, timeout);
  await this.getCreateAccountZip().sendKeys(zip);
  await browser.sleep(1000);
  await this.getCreateAccountZip().sendKeys(protractor.Key.TAB);
  await this.getCreateAccountCity().sendKeys(city);
  await this.getCreateAccountState().sendKeys(state);
  await browser.waitForAngularEnabled(true);
}
async verifyDuplicateAccountWarningScreen(){
   await browser.waitForAngularEnabled(false); 
   await globalMethods.waitForElement(await this.getDuplicateAccountWarningTitle(), true, timeout);
   await globalMethods.verifyElement(await this.getDuplicateAccountWarningTitle(), timeout, true);
   await browser.waitForAngularEnabled(true);
}
/**
 * verifyMyQuestHomePage method verifies for the presence of an element and verifies the url displayed for MyQuest home page.
 */
async verifyMyQuestHomePage(){
   await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getCreateAccount(), true, timeout);
    var currentUrl = await browser.getCurrentUrl();
    await globalMethods.log("url" + currentUrl);
    await globalMethods.verifyTextContains(currentUrl, MyQuestHomePageText, true);
    await browser.waitForAngularEnabled(true);
}
/**
 * verifyCreateAccountPage method verifies the url of create account page. 
 */
async verifyCreateAccountPage(){
   await browser.waitForAngularEnabled(false);
   await globalMethods.waitForElement(await this.getUserName(), true, timeout);
   var currentUrl = await browser.getCurrentUrl();
   await globalMethods.log("url" + currentUrl);
   await globalMethods.verifyTextContains(currentUrl, CreateAccountPageText, true);
   await browser.waitForAngularEnabled(true);
}
/**
 * verifyCloseOnCreateAccountPage method verifies for the presence of of close button on create account page.
 */
async verifyCloseOnCreateAccountPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getUserName(),true,timeout);
    await globalMethods.verifyElement(await this.getClose(), timeout,true);
    await browser.waitForAngularEnabled(true);
}
/**
 * verifyCreateAccountContent method verifies the content displayed on create account page.
 */
async verifyCreateAccountContent(){
   await browser.waitForAngularEnabled(false);
    await globalMethods.log("Verifying the display of text description, username, password, retype password fields on Create Account page");
    await globalMethods.waitForElement(await this.getTextDescription(),true,timeout);
    await globalMethods.verifyElement(await this.getTextDescription(), timeout,true);
    await globalMethods.waitForElement(await this.getUserName(),true,timeout);
    await globalMethods.verifyElement(await this.getUserName(), timeout,true);
    await globalMethods.waitForElement(await this.getPassword(),true,timeout);
    await globalMethods.verifyElement(await this.getPassword(), timeout,true);
    await globalMethods.waitForElement(await this.getRetypePassword(),true,timeout);
    await globalMethods.verifyElement(await this.getRetypePassword(), timeout,true);
    await browser.waitForAngularEnabled(true);
}
/**
 * enterExistingUsername method sends existing username to the username field.
 * @param userName 
 */
async enterExistingUsername(userName){
   var existingUserName = userName;
      await globalMethods.log(existingUserName);
      await globalMethods.sendText(await this.getUserName(), existingUserName, timeout);
      // Using tab to move to next field because "existing user error message" appears only when user either clicks somewhere else on the page or when placed curson in another field
      await this.getUserName().sendKeys(protractor.Key.TAB);
  }

/**
 * verifyExistingErrorMsgOnCreateAccountPage method verifies for the existing error message displayed on the Create Account page.
 * @param errorMessage 
 */
async verifyExistingErrorMsgOnCreateAccountPage(errorMessage){
   var expectedErrorMessage = errorMessage;
   await globalMethods.waitForElement(await this.getUserNameErrorMsg(), true, timeout);
   await globalMethods.log("Username exists error message now displayed");
   var actualErrorMessage = await this.getUserNameErrorMsg().getText().then((text)=>{
       return text.trim();
   });
   await globalMethods.log(expectedErrorMessage+ "======>"+actualErrorMessage);
   await globalMethods.verifyText(expectedErrorMessage, await actualErrorMessage, true);
}
}