import {by, element, browser, ExpectedConditions, ElementArrayFinder, protractor } from 'protractor';
import * as globalMethods from 'quest-global';
import '../global/global';
var global = require('../global/global');
const MQDashboardPageText = '/dashboard';

let timeout = 9500;
let dataFile;
var browserSize;
const faqText ='faq1';
export class Dashboard {
  DashboardURl() {
    return '/dashboard';
  }

  getActivityLink() {
    return element(by.id('db_Feed_btn'));
  }

  viewImportantDatesCard() {
    return element(by.id('db_ImportantDatesDesktop_btn0'));
  }

  getAppointmensLink() {
    return element(by.id('db_Appointments_btn'));
  }

  getParagraphText() {
    return element(by.css('qd-app-root')).getText();
  }

  //Network user buttons are shown by the same ID - How do we identify the difference?
  getNameCardFeed() {
    return element(by.id('mq_NetworkBarUser_btn0'));
  }

  everyoneFeedHeader() {
    return element(by.cssContainingText('.mq-name-card_title', 'Everyone'));
  }

  userFeedHeader() {
    return element(
      by.xpath(
        '//qd-app-root/mq-dashboard[@class="ng-star-inserted"]/mq-page//mq-network//div[@class="dashboard__container"]/section[1]/mq-name-card/mat-card/mat-card-header/h2[@class="mq-name-card__title"]'
      )
    );
  }
  getNameCardTitle(){
    //return element(by.className('mq-name-card__title'));
    return element(by.xpath("//span[@class='mq-name-card__title']"));
  }
  getNameCardTitleOptions() {
    return element(by.xpath("//div[@id='mq_NetworkBar_drp']")).all(by.xpath("//div[@class='mq-network-user__name']"));
  }
  getNameCardDropdownOptions() {
    return element(by.xpath("//div[@id='mq_NetworkBar_drp']"));
  }
  getUserFeedViewMessage(){
    return element(by.id('db_ViewMessage_btn0'));
  }
  getUserFeedButton() {
    return element(by.id('mq_NetworkBarUser_btn1'));
  }

  getUserTwoFeedButton() {
    return element(by.id('mq_NetworkBarUser_btn2'));
  }

  getImportantDateButton() {
    return element(by.id('db_ImportantDatesDesktop_btn0'));
  }
  getImportantDatesNoUpcomingMessages(){
    return element(by.xpath("//h2[@id='db_ImportantDates_txt']/../../..//..//../div[@class='qd-loading-container ng-star-inserted']"));
    //return element(by.xpath('//div[text()="No upcoming appointments right now."]'));
  }
  getImportantDateMessagesMobile(){
    return element(by.xpath("//div[@id='cdk-accordion-child-0']"));
  }
  scheduleAppointmentButton() {
    return element(by.id('mq_ScheduleAppointment_button'));
  }

  viewAppointmentButton() {
    return element(by.id('db_ViewAppointment_btn0'));
  }

  statementButton() {
    return element(by.id('db_ViewStatement_btn0'));
  }

  getViewReport() {
    return element(by.id('db_ViewReport_btn0'));
  }

  getMessagesLink() {
    return element(by.id('db_Messages_btn'));
  }

  getResultsLink() {
    return element(by.id('db_Results_btn'));
  }

  getBillingLink() {
    return element(by.id('db_Billing_btn'));
  }

  addAnother() {
    return element(by.xpath("//span[contains(text(),'Add Another')]"));
  }

  mobileNetworkDropDown() {
    return element(by.id('mq_NetworkBar_drp'));
  }

  mobileImportantDates() {
    return element(by.id('db_ImportantDatesMobile_txt'));
  }

  mobileActionButton() {
    return element(by.id('mq_Action_btn'));
  }

  mobileScheduleAppointment() {
    return element(by.id('mq_ScheduleAppointmentMobile_btn'));
  }

  mobileManualLabRequest() {
    return element(by.id('mq_ManualLabRequestMobile_btn'));
  }

  mobileComposeMessage() {
    return element(by.id('mq_ComposeNewMessageMobile_btn'));
  }

  mobileAddContact() {
    return element(by.id('mq_AddContactMobile_btn'));
  }

  getAddAFamilyMember() {
    //return element(by.id('mq_NetworkBarGetStarted_btn'));
    return globalMethods.getElementByXpath("//button[@id='mq_NetworkBarGetStarted_btn']");
  }

  getScheduleAnAppointment() {
    return element(by.id('mq_ScheduleAppointment_button_main'));
  }
  scheduleNowButton() {
    return element(by.id('db_OrderScheduleNow_btn4')); //Not a static button need to visit how to handle
  }
  verificationRequiredNetUser() {
    return element(by.cssContainingText('.mq-network-user__verification-text', 'Verification Required '));
  }

  getNoAppointments() {
    return element(by.cssContainingText('div', 'No upcoming appointments right now.'));
  }

  getScheduledAppointments() {
    return element.all(by.css('qd-calendar-icon'));
  }
  getImportantDates() {
    return element(by.id('db_ImportantDates_txt'));
  }
  getBreadCrumb(){
    return element(by.xpath("//nav[@aria-label='breadcrumbs']"));
  }
  getDescriptionInFamilyCircle(){
    return element(by.xpath("//p[@class='mq-network__description']"));
  }
  getUserOnFamilyCircleSection(){
    return element(by.xpath("//div[@class='mq-network-user mq-network-user--active']//div[contains(text(),'Auto FamilyCircleUserDescription')]"));
  }
  getNoFeeds() {
    return element(by.xpath("//div[contains(text(),'No feed events right now.')]"));
  }
  getTestResultsCard() {
    return element (by.xpath("//mat-card[@class='db-feed-card mat-card db-feed-card--first']"));
   }
  getTestResultsCardTitle() {
    //return element (by.xpath("//*[contains(text(),'test results are available')]"));
    return globalMethods.getElementByXpath("//mat-card-title[@class='db-feed-card__title mat-card-title']");
  }
  getTestCompletedDate() {
    return element(by.xpath("//mat-card[@class='db-feed-card mat-card db-feed-card--first']//mat-card-subtitle"));
   //return globalMethods.getElementByXpath("//mat-card-subtitle[@class='db-feed-card__subtitle mat-card-subtitle']");
  }  
  getTestResultsCardMessage() {
    return element(by.xpath("//mat-card[@class='db-feed-card mat-card db-feed-card--first']//p"));
  }
  getListOfFirstUsers() {
    return element(by.xpath("//div[@aria-label='My Circle Filters']/button[1]"));
  }
  getListOfAllUsers() {
    let items = element(by.xpath("//div[@aria-label='My Circle Filters']")).all(by.tagName("button"));
    return items;
  }
  getFirstNameInitial() {
    return globalMethods.getElementByXpath("//div[@class='mq-network-user mq-network-user--active']//div[@aria-label='avatar']");
  }
  getDependentUser() {
    return globalMethods.getElementByXpath("//button[@id='mq_NetworkBarUser_btn1']");
  }
  getDependentUserActive() {
    return globalMethods.getElementByXpath("//button[@id='mq_NetworkBarUser_btn1']//div[@class='mq-network-user mq-network-user--active']");
  }
  getImportantDatesCard(){
    return globalMethods.getElementByXpath("//article[@aria-label='important dates']");
  }
  getImportantDatesEventTitle(){
    return globalMethods.getElementByXpath("//a[@id='db_ImportantDatesDesktop_btn0']//div[@class='db-important-dates__event mat-line']");
  }
  getImportantDatesCalendarIcon(){
    return globalMethods.getElementByXpath("//a[@id='db_ImportantDatesDesktop_btn0']//qd-calendar-icon");
  }
  getImportantDatesName(){
    return globalMethods.getElementByXpath("//a[@id='db_ImportantDatesDesktop_btn0']//div[@class='db-important-dates__name mat-line']");
  }
  getFirstEventGroupedBasedOnDates(){
    //return globalMethods.getElementByXpath("//h3[@id='db_FeedGroupDate_txt0']/following-sibling::ul[@aria-labelledby='db_FeedGroupDate_txt0']");
    return globalMethods.getElementByXpath("//h2[starts-with(@id,'db_FeedGroupDate_txt')][1]");
  }
  getSecondEventGroupedBasedOnDates(){
    //return globalMethods.getElementByXpath("//h3[@id='db_FeedGroupDate_txt1']/following-sibling::ul[@aria-labelledby='db_FeedGroupDate_txt1']");
    return globalMethods.getElementByXpath("//h2[starts-with(@id,'db_FeedGroupDate_txt')][2]");
  }
  getFirstEventDate(){
    return globalMethods.getElementById('db_FeedGroupDate_txt0');
  }
  getSecondEventDate(){
    return globalMethods.getElementById('db_FeedGroupDate_txt1');
  }
  getImportantDatesCardMobile(){
    return globalMethods.getElementByXpath("//article[@aria-label='important dates']//..//mat-expansion-panel-header");
  }
  getImportantDatesFutureEventsCardMobile(){
    return globalMethods.getElementByXpath("//a[@id='db_ImportantDatesDesktop_btn0']");
  }
  getNotificationsCloseMobile(){
    return globalMethods.getElementById("nav-not_CloseButton_Btn");
  }
  getFaqMobile() {
      return globalMethods.getElementByXpath("//a[@id='faq']");
  }
  getContactQuest() {
    return element(by.id('contact-quest'));
  }
  getMessageQuest() {
    return element(by.id('contactDialog'));
  }
  getMessageQuestMobile() {
    //return element(by.id('contactDialog'));
    return globalMethods.getElementByXpath("//button[@aria-label='Message Quest']");
  }
  getImportantDatesEventTitleMobile(){
    return globalMethods.getElementByXpath("//a[@id='db_ImportantDatesMobile_btn0']//div[@class='db-important-dates__event mat-line']");
    //[contains(text(),'Lab Appointment')]
  }
  
// Setters
  async clickImportantDate(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getImportantDateButton(), true,timeout);
    await globalMethods.click(await this.getImportantDateButton(), 'Important Date Button', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickActivity method clicks on Activity link of Dashboard page.
   */
  async clickActivity(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getActivityLink(), 'Activity Link', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickAppointments method clicks on Appointments link of Dashboard page.
   */
  async clickAppointments(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getAppointmensLink(), true, timeout);
    await globalMethods.log("Appointment link is now visible");
    await globalMethods.click(await this.getAppointmensLink(), 'Appointmens Link', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickResults clicks on 'Results' link on Dashoard page. This method works for both desktop and mobile viewport
   */
  async clickResults(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getResultsLink(), true, timeout);
    await globalMethods.log("result link is now visible");
    await globalMethods.click(await this.getResultsLink(), 'Results Link', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickPayBills method clicks on billing link of Dashboard page.
   */
  async clickPayBills(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getBillingLink(), 'Billing Link', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickMessages method clicks on messages link of Dashboard page.
   */
  async clickMessages(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getMessagesLink(), true, timeout);
    await globalMethods.log("Messages link is now visible");
    await globalMethods.click(await this.getMessagesLink(), 'Messages Link', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickNameCardFeed(): Promise<void>{
    await globalMethods.click(await this.getNameCardFeed(), 'Name Card Feed', timeout);
  }
  async clickUserFeedViewMessage(): Promise<void>{
    await globalMethods.click(await this.getUserFeedViewMessage(), 'User Feed View Message', timeout);
  }
  async clickViewReport(): Promise<void>{
    await globalMethods.click(await this.getViewReport(), 'View Report', timeout);
  }
  /**
   * clickAddAFamilyMember method clicks on 'Add A Family Member' button in family section of dashboard page.
   */
  async clickAddAFamilyMember(): Promise<void>{
    //await globalMethods.click(await this.getAddAFamilyMember(), 'Add A Family Member', timeout);
    await browser.waitForAngularEnabled(false);
    await globalMethods.log("Clicking Add a family member");
    await globalMethods.waitForElement(await this.getAddAFamilyMember(), true, timeout);    
    await globalMethods.waitForVisible(await this.getAddAFamilyMember(), timeout);
    //await browser.executeScript('arguments[0].click();', await this.getAddAFamilyMember());
    await globalMethods.click(await this.getAddAFamilyMember(), 'Add A Family Member', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickAddAnother method clicks on 'Add Another' button in family section of dashboard page.
   */
  async clickAddAnother(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.addAnother(), true, timeout);
    await globalMethods.waitForVisible(await this.addAnother(), timeout);
    await globalMethods.click(await this.addAnother(), 'Add Another', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureClickAddInFamilySection method clicks on AddAnother button available in family section of dashboard page if addType is provided as AddAnother in test data file. 
   * If addType is not specified, it clicks on 'Add A Family Member' button.
   * @param addType 
   */
  async procedureClickAddInFamilySection(addType){    
    await browser.waitForAngularEnabled(false);
    switch(addType){
    case 'AddAnother':
      await this.clickAddAnother();
      break;
    default:
       await this.clickAddAFamilyMember();
       break;
  }   
  await browser.waitForAngularEnabled(true);
}
async clickDependentUser(): Promise<void>{
  await globalMethods.click(await this.getDependentUser(), 'Dependent User on Dashboard', timeout);
}
async clickPlus(){
  await browser.waitForAngularEnabled(false);
  await globalMethods.waitForElement(await this.mobileActionButton(), true, timeout);
  await globalMethods.click(await this.mobileActionButton(), 'Mobile Action - Plus', timeout);
  await browser.waitForAngularEnabled(true);
}
async clickRequestTestResults(){
  await globalMethods.waitForElement(await this.mobileManualLabRequest(), true, timeout);
  await globalMethods.click(await this.mobileManualLabRequest(), 'Mobile - Request Test Result', timeout);
}
async procedureVerifyEventsGroupedBasedOnDates(){
  await browser.waitForAngularEnabled(false);
  await globalMethods.log("Verifying the events are grouped together based on date1");
  await globalMethods.waitForElement(await this.getFirstEventGroupedBasedOnDates(), true, timeout);
  await globalMethods.verifyElement(await this.getFirstEventGroupedBasedOnDates(), timeout, true);
  await globalMethods.log("Verifying the events are grouped together based on date2")
  await globalMethods.waitForElement(await this.getSecondEventGroupedBasedOnDates(), true, timeout);
  await globalMethods.verifyElement(await this.getSecondEventGroupedBasedOnDates(), timeout, true);
  await browser.waitForAngularEnabled(true);
}
async procedureVerifyEventDates(){
  await browser.waitForAngularEnabled(false);
  await globalMethods.log("Verifying the first event date");
  await globalMethods.waitForElement(await this.getFirstEventDate(), true, timeout);
  await globalMethods.verifyElement(await this.getFirstEventDate(), timeout, true);
  await globalMethods.log("Verifying the second event date");
  await globalMethods.waitForElement(await this.getSecondEventDate(), true, timeout);
  await globalMethods.verifyElement(await this.getSecondEventDate(), timeout, true);
  await browser.waitForAngularEnabled(true);
}
/**
 * verifyUserNameOnNameCard method is verifying login UserName
 * @param filename 
 */
async verifyUserNameOnNameCard(filename) {
  var featureName = filename.substring(0, filename.indexOf("-"));
    dataFile = await global.getData(featureName, filename);
    let Desktop= await dataFile.desktop;
    let Mobile= await dataFile.mobile;

  if (Desktop) {
    await browser.waitForAngularEnabled(false);
    await this.getNameCardTitle().getText().then(async function(text){
        var temp = text.toString().trim();
        console.log("Text = "+ temp);
        globalMethods.validateText(temp, dataFile.nameCard, true);
      });
    await browser.waitForAngularEnabled(true);
  }

  if (Mobile){
  browser.waitForAngularEnabled(false);
  await globalMethods.waitForElement(await this.getNameCardTitleOptions().first(), true, timeout);
   await globalMethods.log("Total results:" + await this.getNameCardTitleOptions().count());
   var count = await this.getNameCardTitleOptions().count();
   for (let i = 0; i < count; i++) {
      var expectedNameCard = dataFile.nameCard.toUpperCase().trim();
      var actualNameCard = await this.getNameCardTitleOptions().get(i).getText().then(async function(text)
      {
        return await text.toString().trim().toUpperCase();
      });
     await globalMethods.verifyText(actualNameCard, expectedNameCard, true);
     var retVal = await globalMethods.textContains(expectedNameCard, actualNameCard);
       if (retVal) {
          await globalMethods.verifyText(await expectedNameCard, actualNameCard, true);
          break;
       }
   }
   browser.waitForAngularEnabled(true);
  }
}


/**
 * In EveryoneOnNamecard method verifying the Everyone name from name card in mobile and desktop view
 * @param filename 
 */
async EveryoneOnNamecard(filename) {
  var featureName = filename.substring(0, filename.indexOf("-"));
    dataFile = await global.getData(featureName, filename);
    let Desktop= await dataFile.desktop;
    let Mobile= await dataFile.mobile;

  if (Desktop) {
    await browser.waitForAngularEnabled(false);
    var expectedNameCard = dataFile.nameCard.toUpperCase().trim();
    await globalMethods.waitForElement(await this.getNameCardTitle(), true, timeout);
      var actualNameCard = await this.getNameCardTitle().getText().then(async function(text){
        return await text.toString().trim().toUpperCase();
      });
    await globalMethods.log("ExpectedNameCard:>"+[expectedNameCard]    +"ActualNameCard:>"+[actualNameCard])
    await globalMethods.verifyText(expectedNameCard, actualNameCard, true);
    await browser.waitForAngularEnabled(true);
  }

  if (Mobile){
  browser.waitForAngularEnabled(false);
  await globalMethods.waitForElement(await this.getNameCardTitleOptions().first(), true, timeout);
   await globalMethods.log("Total results:" + await this.getNameCardTitleOptions().count());
   var count = await this.getNameCardTitleOptions().count();
   for (let i = 0; i < count; i++) {
      var expectedNameCard = dataFile.nameCard.toUpperCase().trim();
      var actualNameCard = await this.getNameCardTitleOptions().get(i).getText().then(async function(text){
        return await text.toString().trim().toUpperCase();
      });
     await globalMethods.verifyText(actualNameCard, expectedNameCard, true);
     var retVal = await globalMethods.textContains(expectedNameCard, actualNameCard);
       if (retVal) {
          await globalMethods.verifyText(await expectedNameCard, actualNameCard, true);
          break;
       }
   }
   browser.waitForAngularEnabled(true);
  }
}
/**
 * ClickOnNameCardDropdown method is to click on NameCardDropdown in mobile view port
 */
async ClickOnNameCardDropdown(){
  await browser.waitForAngularEnabled(false);
  await globalMethods.waitForElement(await this.getNameCardDropdownOptions(), true, timeout);
  await this.getNameCardDropdownOptions().click();
  await browser.waitForAngularEnabled(true);
}
/**
 * clickUser method is getting required NameCard from data file and click on NameCard
 * @param filename 
 */
async clickUser(filename){
  var featureName = filename.substring(0, filename.indexOf("-"));
    dataFile = await global.getData(featureName, filename);

  browser.waitForAngularEnabled(false);
  var expectedItem =await dataFile.nameCard.toUpperCase().trim();
  await globalMethods.waitForElement(await this.getNameCardTitleOptions().first(),true, timeout);
  await globalMethods.log("Total results:" + await this.getNameCardTitleOptions().count());
  var count = await this.getNameCardTitleOptions().count();
  for (let i = 0; i < count; i++) {
      var visualFilterText = await this.getNameCardTitleOptions().get(i).getText();
      var actualItem = await visualFilterText.toUpperCase().trim();
      await globalMethods.log("Visual Filters[" + i + "]");
      await globalMethods.log(visualFilterText);
      if(actualItem === expectedItem){
          var retVal = true;
          await globalMethods.log(actualItem+"==="+expectedItem);
      }
      if (retVal) {
          await globalMethods.log("retVal is :" + retVal);
          await this.getNameCardTitleOptions().get(i).click();
          break;
      }
  }
  browser.waitForAngularEnabled(true);
}
/**
 * verifyImportantDatesCard method is verifying ImportantDatesCard section in mobile view
 */
async verifyImportantDatesCard(){
  browser.waitForAngularEnabled(false);
  await globalMethods.verifyElement(await this.getImportantDatesCardMobile(), timeout, true)
  browser.waitForAngularEnabled(true);
}
/**
 * clickImportantDatesCard method is to click on ImportantDatesCard section in mobile view
 */
async clickImportantDatesCard(){
  browser.waitForAngularEnabled(false);
  await globalMethods.waitForElement(await this.getImportantDatesCardMobile(), true, timeout)
  await globalMethods.waitForClickable(await this.getImportantDatesCardMobile(), timeout)
  await this.getImportantDatesCardMobile().click();
  browser.waitForAngularEnabled(true);
}
/**
 * verifyNoAppointmentsMessage method is to verify application text Message when there is no Appointments
 * @param filename 
 */
async verifyNoAppointmentsMessage(filename) {
  var featureName = filename.substring(0, filename.indexOf("-"));
    dataFile = await global.getData(featureName, filename);
    let Desktop= await dataFile.desktop;
    let Mobile= await dataFile.mobile;

  if (Desktop) {
    await browser.waitForAngularEnabled(false);
    var expectedMessage = dataFile.message.toUpperCase().trim();
    await globalMethods.waitForElement(await this.getImportantDatesNoUpcomingMessages(), true, timeout);
    await globalMethods.waitForVisible(await this.getImportantDatesNoUpcomingMessages(), timeout);
      var actualMessage = await this.getImportantDatesNoUpcomingMessages().getText().then(async function(text){
        return await text.toString().trim().toUpperCase();
      });
    await globalMethods.log("ExpectedNameCard:>"+[expectedMessage]    +"=== Actual Message:> "+[actualMessage])
    await globalMethods.verifyText(expectedMessage, actualMessage, true);
    await browser.waitForAngularEnabled(true);
  }

  if (Mobile){
    await browser.waitForAngularEnabled(false);
    var expectedMessage = dataFile.message.toUpperCase().trim();
    await globalMethods.waitForElement(await this.getImportantDateMessagesMobile(), true, timeout);
      var actualMessage = await this.getImportantDateMessagesMobile().getText().then(async function(text){
        return await text.toString().trim().toUpperCase();
      });
    await globalMethods.log("ExpectedNameCard:>"+[expectedMessage]    +"=== Actual Message:>"+[actualMessage])
    await globalMethods.verifyText(expectedMessage, actualMessage, true);
    await browser.waitForAngularEnabled(true);
  }
}
/**
 * verifyImportantDatesFutureEventsCardMobile is to verify Future Events inside ImportantDate section
 */
async verifyImportantDatesFutureEventsCardMobile(){
  await browser.waitForAngularEnabled(false);
  await globalMethods.waitForElement(await this.getImportantDatesFutureEventsCardMobile(), true, timeout);
  await globalMethods.verifyElement(await this.getImportantDatesFutureEventsCardMobile(),timeout, true);
  await browser.waitForAngularEnabled(true);
}
/**
 * verifyDashboardPageFromNotificationsPage method verifies the presence of an element in dashboard page
 */
async verifyDashboardPageFromNotificationsPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getActivityLink(), true, timeout);
    await globalMethods.verifyElement(await this.getActivityLink(), timeout, true);
    await globalMethods.log("In Dashboard Page");
    await browser.waitForAngularEnabled(true);
}
/**
 *procedureVerifyBreadcrumb method verifies and compares the actual breadcrumb text with expected text.
 */
async procedureVerifyBreadcrumb(dataFile){
  var breadCrumbText = dataFile.breadCrumb;
  await browser.waitForAngularEnabled(false);
  await this.getBreadCrumb().getText().then(async function(text){
    var temp = text.toString().trim();
    await globalMethods.log("Text = "+ temp);
    await globalMethods.verifyTextContains(temp, breadCrumbText, true);
  });
  await browser.waitForAngularEnabled(true);
}
/**
 * verifyDashboardPage method verifies the url of dashboard page.
 */
async verifyDashboardPage(){
  await browser.waitForAngularEnabled(false);
    var currentUrl = await browser.getCurrentUrl();
    await globalMethods.log(currentUrl);
    await globalMethods.verifyTextContains(currentUrl, MQDashboardPageText, true);
    await browser.waitForAngularEnabled(true);
}
/**
 * verifyScheduleAnAppointment method verifies for the presence of Schedule An Appointment button on MyQuest Home page.
 */
async verifyScheduleAnAppointment(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getScheduleAnAppointment(), true, timeout);
    await globalMethods.verifyElement(await this.getScheduleAnAppointment(), timeout, true);
    await browser.waitForAngularEnabled(true);
}
async clickDashboardFAQ(){
  //await globalMethods.click(await this.getFaqMobile(), "Dashboard FAQ option", timeout);
  browserSize = await globalMethods.getConfigBrowserSize();
  await globalMethods.log("Browser Size Params:" + browser.params.viewport);
  
  await browser.waitForAngularEnabled(false);
  
  if(await globalMethods.waitForElement(await this.getNotificationsCloseMobile(), true, timeout)){
    await globalMethods.click(await this.getNotificationsCloseMobile(), 'Close button of Notifications in Mobile', timeout);
  }      
  await globalMethods.click(await this.getContactQuest(), 'Help from Contact Quest', timeout);
  await globalMethods.waitForElement(await this.getFaqMobile(), true, timeout);
  await globalMethods.click(await this.getFaqMobile(), "FAQ Mobile", timeout);
  await browser.waitForAngularEnabled(true);
}

async clickMessageQuest(){
  //await globalMethods.click(await this.getMessageQuest(), 'Message Quest', timeout);
 
    browserSize = await globalMethods.getConfigBrowserSize();
    await globalMethods.log("Browser Size Params:" + browser.params.viewport);
    
    await browser.waitForAngularEnabled(false);
    if (browserSize === 'md' || browserSize === 'lg') {
    await globalMethods.waitForElement(await this.getMessageQuest(), true, timeout);
    await globalMethods.click(await this.getMessageQuest(), 'Message Quest', timeout);
    return;
    }
    if(await globalMethods.waitForElement(await this.getNotificationsCloseMobile(), true, timeout)){
      await globalMethods.click(await this.getNotificationsCloseMobile(), 'Close button of Notifications in Mobile', timeout);
    }      
    await globalMethods.click(await this.getContactQuest(), 'Help from Contact Quest', timeout);
    await globalMethods.waitForElement(await this.getMessageQuestMobile(), true, timeout);
    await globalMethods.click(await this.getMessageQuestMobile(), "Message Quest Mobile", timeout);
    await browser.waitForAngularEnabled(true);
}

async clickContactQuest(){
  await browser.waitForAngularEnabled(false);
  await globalMethods.waitForElement(await this.getContactQuest(), true, timeout );
  //await globalMethods.click(await this.getContactQuest(), 'Help from Contact Quest', timeout);
  await globalMethods.mouseMove(await this.getContactQuest(), "Help from Contact Quest", timeout);
  await browser.waitForAngularEnabled(true);
}

async verifyFAQPageInNewTab(){
  await globalMethods.switchTabs(1).then(async function() {
    await browser.waitForAngularEnabled(false);
    console.log("Ignore Synchronization set to true");
    var currentUrl = await browser.getCurrentUrl();
    await globalMethods.log(currentUrl);
    await globalMethods.verifyTextContains(currentUrl, faqText, true);
  });
  await globalMethods.closeTab();
  console.log("Ignore Synchronization set to false");
  await browser.waitForAngularEnabled(true);
  await globalMethods.switchTabs(0);
}
/**
 * verifyEventTitleonImportantDatesCard method verifies for event title displayed on Important Dates card section.  
 * This metho uses parameters: eventTitle, mobile or desktop.
 *   @param dataFile 
 */
async verifyEventTitleonImportantDatesCard(dataFile){
    let Desktop= await dataFile.desktop;
    let Mobile= await dataFile.mobile;
    await browser.waitForAngularEnabled(false);
    await globalMethods.log("Verifying Event Title of Important Dates Card section on the dashboard page");
    if(Desktop){
    await globalMethods.waitForElement(await this.getImportantDatesEventTitle(), true,timeout);
    await globalMethods.verifyElement(await this.getImportantDatesEventTitle(), timeout, true);
    var actualEventTitle = await this.getImportantDatesEventTitle().getText().then(async function(text){
        return text.toString().trim().toLowerCase();
    });
    await globalMethods.verifyText(actualEventTitle, dataFile.eventTitle, true);
    }

    if(Mobile){
      await globalMethods.waitForElement(await this.getImportantDatesEventTitleMobile(), true,timeout);
      await globalMethods.verifyElement(await this.getImportantDatesEventTitleMobile(), timeout, true);
      var actualEventTitle = await this.getImportantDatesEventTitleMobile().getText().then(async function(text){
        return text.toString().trim().toLowerCase();
    });
      await globalMethods.verifyText(actualEventTitle, dataFile.eventTitle, true);
    }
    
    await browser.waitForAngularEnabled(true);
}
}