import { browser, by, element } from 'protractor';
import * as globalMethods from 'quest-global';

let timeout=9500;
let dataFile;
const newMessagesPageText = '/messages/new';
const messagesPageText = '/messages';
var currentUrl;
export class Messages {
  MessagesURL() {
    return '/messages';
  }
  composeNewsMessagesURL() {
    return '/messages/new';
  }

  MessagesPageValidator() {
    return this.getComposeNewMessage();
  }
  getMessageActivityLog() {
    return element(by.id('msg_ActivityLog_btn'));
  }
  navigateTo() {
    return browser.get('/messages');
  }
  getMessagesLink(){
    return element(by.id('db_Messages_btn'));
  }
  getComposeNewMessage() {
    return element(by.id('msg_ComposeNewMessage_btn'));
  }
  messageBreadCrumb() {
    return element(by.id('db_messagesCrumb_btn'));
  }

  getParagraphText() {
    return element(by.css('qd-app-root')).getText();
  }
  mobileNetworkDropDown() {
    return element(by.id('mq_NetworkBar_drp'));
  }

  mobileImportantDates() {
    return element(by.id('db_ImportantDatesMobile_txt'));
  }

  mobileActionButton() {
    return element(by.id('mq_Action_btn'));
  }

  mobileScheduleAppointment() {
    return element(by.id('mq_ScheduleAppointmentMobile_btn'));
  }
  mobileManualLabRequest() {
    return element(by.id('mq_ManualLabRequestMobile_btn'));
  }
  mobileComposeMessage() {
    return element(by.id('mq_ComposeNewMessageMobile_btn'));
  }
  mobileAddContact() {
    return element(by.id('mq_AddContactMobile_btn'));
  }
  appointmentButton() {
    return element(by.id('db_Appointments_btn'));
  }
  messageInboxOne() {
    return element(by.id('msg_MessageCard_btn0'));
  }
  getMessageInboxTab() {
    return element(by.id('qd_inbox_btn'));
  }
  getMessageSentTab() {
    return element(by.id('qd_sent_btn'));
  }
  messageSentclick() {
    return element(by.cssContainingText('mat-button-wrapper', 'Sent'));
  }
  messageFromField() {
    return element(by.id('msg_MessageFrom_drp'));
  }
  getMessageToField() {
    return element(by.id('msg_MessageTo_txt'));
  }
  getMessageSubjectField() {
    return element(by.id('msg_AddMessageSubject_txt'));
  }
  getCancel() {
    return element(by.xpath("//mat-icon[contains(text(),'cancel')]"));
  }
  getMessageTextField() {
    return element(by.id('msg_AddMessageText_txt'));
  }
  getSend() {
    return element(by.id('msg_MessageSubmit_btn'));
  }
  messageDiscardButton() {
    return element(by.id('msg_MessageDiscard_btn'));
  }
  messageJohnDoe() {
    return element(by.cssContainingText('.msg-send-form__from-name', 'John Doe'));
  }
  getSuccessMessage() {
    return element(by.id('success-title'));
  }
  messageDismissButton() {
    return element(by.id('mq_SuccessDismiss_btn'));
  }
  inboxHasAttachments() {
    return element(by.id('msg_HasAttachmentsFilter_chk'));
  }
  inboxReceivedFrom() {
    return element(by.id('msg_ReceivedFromFilter_drp'));
  }
  inboxReceivedFromElement() {    
    // Sowjanya 8/8: Had to hard code this value bcos, after clicking on the drop down it is not able to find the value.
    //return element(by.xpath("//span[@class='mat-option-text'][contains(text(),'AutoMQMessagesFwdsuccess@gazelle.direct.dir-next-app01.qa.medplus.com')]"));
    return globalMethods.getElementByXpath("//select[@id='msg_ReceivedFromFilter_drp']/option[contains(text(),'AutoMQMessagesFwdsuccess')]");
  }
  inboxReceivedFromSendMessagesAttachResults() {
    //return element(by.xpath("//span[@class='mat-option-text'][contains(text(),'SendMessagesAttachResults@gazelle.direct.dir-next-app01.qa.medplus.com')]"));
    return globalMethods.getElementByXpath("//select[@id='msg_ReceivedFromFilter_drp']/option[contains(text(),'SendMessagesAttachResults')]");
  }
  inboxBoxSortBy() {
    return element(by.id('msg_Sort_drp'));
  }
  inboxFirstMessageCard() {
    return element(by.id('msg_MessageCard_btn0'));
  }
  sentSentToSort() {
    return element(by.id('msg_SentToFilter_drp'));
  }
  getClose() {
    return element(by.id('gl_CloseButton_Btn'));
  }
  messageFromDateSort() {
    return element(by.id('al_FromDateFilter_date'));
  }
  messageToDateSort() {
    return element(by.id('al_ToDateFilter_date'));
  }
  activityLogSortBy() {
    return element(by.id('al_Sort_drp'));
  }
  inboxMostRecentFirstSort() {
    //return element(by.cssContainingText('.mat-option-text', ' Most Recent First'));
    return globalMethods.getElementByXpath("//option[contains(text(),'Most Recent First')]");
  }
  inboxOldestFirstSort() {
    //return element(by.cssContainingText('.mat-option-text', ' Oldest First'));
    return globalMethods.getElementByXpath("//option[contains(text(),'Oldest First')]");
  }
  inboxReceivedFromSortAllPhysicians() {
    return element(by.cssContainingText('.mat-option-text', 'All Physicians'));
  }
  sentSortToALl() {
    return element(by.cssContainingText('.mat-option-text', 'All'));
  }
  messageResetFilter() {
    return element(by.id('mq_ResetFilters_btn'));
  }
  messageForward() {
    return element(by.id('msg_Forward_btn'));
  }
  getMessageReply() {
    return element(by.id('msg_Reply_btn'));
  }
  messageAddAttachment() {
    return element(by.id('msg_AttachLabReport_btn'));
  }
  messageConfirmAddAttachment() {
    return element(by.id('msga_Attach_btn'));
  }
  addlabResultOne() {
    return element(by.id('msga_lab0_chk'));
  }
  messageClearAttachment() {
    return element(by.id('msg_ClearFile_btn'));
  }
  messageCheckboxCCDA() {
    return element(by.id('msg_IncludeCcda_chk'));
  }
  getMessageGear() {
    return element(by.id('msg_SettingsGear_btn'));
  }
  getMessageConnectPhysician() {
    return element(by.id('msg_ConnectPhysician_btn'));
  }
  newPCPaitentLastNameField() {
    return element(by.id('mq-PhysicianConnectLastName_txt'));
  }
  newPCPaitentDobField() {
    return element(by.id('mq_PhysicianConnectDateOfBirth_txt'));
  }
  newPCPaitentPinField() {
    return element(by.id('mq_PhysicianConnectPin_txt'));
  }
  newPCPaitentConnectBtn() {
    return element(by.id('mq_PhysicianConnect_btn'));
  }
  newPCPaitentCancelConnectBtn() {
    return element(by.id('mq_CancelPhysicianConnect_btn'));
  }
  getCreateDirectEmailAddress() {
    return element(by.xpath("//button[@type='submit']"));
  }
  getMessageCard() {
    return element(by.xpath("//div[@class='db-feed__cards']//ul//li[@aria-label='message']"));
  }
  getMessageCardHeader() {
    return element(by.xpath("//div[@class='db-feed__cards']//ul//li[@aria-label='message']//mat-card-title//h4"));
  }
  getMessageCardSubject(){
    return element(by.xpath("//div[@class='db-feed__cards']//ul//li[@aria-label='message']//db-feed-card-message/p"));
  }
  getMessageTitle(){
    return element(by.xpath("//h2[@class='direct-address-form__title'"));
  }
  getActionsRequiredText(){
    return element(by.xpath("//p[@class='mq-actions-required__text']"));
  }
  getFirstInboxMessage() {
    return element(by.xpath("//div[@class='msg-list']//..//ul//li[1]"));
  }
  getListOfAllInboxMessage() {
    let items = element(by.xpath("//div[@class='msg-list']//ul")).all(by.tagName("li"));
    return items;
  }
  getUnreadResults() {
    return element(by.xpath("//div[@class='rs-card__card rs-card--unread']"));
  }
  getUnreadInboxMessage() {
    return element(by.xpath("//div[@class='msg-list-item__inner msg-list-item--unread']"));
  }
  getMessage() {
    return element(by.xpath("//p[@class='message-detail__body']"));
  }
  getFirstMessagesCard() {
    return element (by.xpath("//ul[@aria-label='messages']")).all(by.tagName("li")).first();
  }
  getAllMessages() {
    let messages = element(by.xpath("//ul[@aria-label='messages']")).all(by.tagName("li"));
    return messages;
  }
  getWelcomeMessage() {
    //return element(by.xpath("//a[@aria-label='View details for message received from MyQuest']"));
    return element(by.xpath("//a[contains(@aria-label, 'received from MyQuest')]"));
  }
  getLowerContentText(){
    return element(by.xpath("//p[@class='mq-phys-connect__lower-content__text mq-phys-connect__text--bold']"));
  }
  getPCLowerContentText() {
    return element(by.xpath("//p[@class='mq-phys-connect__lower-content__text mq-phys-connect__text--gray']"));
  }
  selectAttachTestResult() {
    return element(by.xpath("//mat-checkbox[@id='mat-checkbox-2']"));
    //mat-checkbox[@id='mat-checkbox-2']//div[@class='mat-checkbox-inner-container mat-checkbox-inner-container-no-side-margin']
  }
  getIncludeCCDA() {
    return element (by.id('msg_IncludeCcda_chk-input'));
  }
  getIncludeCCDAText() {
    return element(by.xpath("//span[@class='mat-checkbox-label']"));
  }
  getCancelTestResult() {
    return element(by.id("msga_Cancel_btn"));
  }
  getPrePopulatedEmailId() {
    return element(by.xpath("//mat-chip-list[@id='mat-chip-list-0']/div/mat-chip"));
  }
  getErrorMsgForValidEmail() {
    return element(by.xpath("//div[@class='mat-form-field-subscript-wrapper']/div/mat-error"));
  }
  getErrorMsgforToField(){
    //return element(by.xpath("//mat-error[@id='mat-error-1']"));
    return globalMethods.getElementByXpath("//mat-form-field[@id='msg_MessageTo_txt']/following::mat-error");
  }
  getErrorMsgforSubjectField() {
    //return element(by.xpath("//mat-error[@id='mat-error-2']"));
    return globalMethods.getElementByXpath("//mat-form-field[@id='msg_MessageSubject_txt']/following::mat-error");
  }
  getErrorMsgforMessageTextField() {
    //return element(by.xpath("//mat-error[@id='mat-error-3']"));
    return globalMethods.getElementByXpath("//textarea[@id='msg_AddMessageText_txt']/following::mat-error");
    
  }
  getErrorMsgForInvalidPINConnection() {
    return globalMethods.getElementByXpath("//qd-api-errors/div/div");
  }
  getDirectAddressModal() {
    return globalMethods.getElementByXpath("//div[@class='direct-address-form__container']");
  }
  getDAMTitle() {
    return globalMethods.getElementByXpath("//h2[@class='direct-address-form__title']");
  }
  getDAMText() {
    return globalMethods.getElementByXpath("//p[@class='direct-address-form__subheader']")
  }
  getDAMEmailPrefix() {
    return globalMethods.getElementById("mat-input-0");
  }
  getDAMEmailSuffix() {
    return globalMethods.getElementByXpath("//span[@class='direct-address-form__input-suffix']");
  }
  getCreateDirectEmailAddressButton() {
    return globalMethods.getElementByXpath("//button[@class='mat-raised-button mat-primary']");
  }
  getDAMError() {
    return globalMethods.getElementByXpath("//div[@class='mat-form-field-subscript-wrapper']/div/mat-error");
  }
  getDAMSuccess() {
    return globalMethods.getElementByXpath("//div[@class='direct-address-form__hint-success']/span");
  }
  getHasAttachments() {
    return globalMethods.getElementByXpath("//label[@for='msg_HasAttachmentsFilter_chk-input']/div");
  }
  getMessagesHasAttachments() {
    return globalMethods.getElementByXpath("//span[@aria-label='message has attachments']");
  }
  
  getClipIcon() {
    return globalMethods.getElementByXpath("//span[@aria-label='message has attachments']/mat-icon");
  }
  getReceivedFromMessages() {
    //return globalMethods.getElementByXpath("//a[@aria-label='View details for message received from AutoMQMessagesFwdsuccess@gazelle.direct.dir-next-app01.qa.medplus.com']");
    return globalMethods.getElementByXpath("//a[contains(@aria-label,'SendMessagesAttachResults')]");
  }
  getFromDate() {
    return globalMethods.getElementById("msga_labFrom_date");
  }
  getToDate() {
    return globalMethods.getElementById("msga_labTo_date");
  }
  getAllMessagesDates() {
    let messages = element(by.xpath("//ul[@aria-label='messages']")).all(by.xpath("//span[@class='msg-list-item__date']"));
    return messages;
  }
  getAllMessageDatesContainingAttachments() {
    let messages = element(by.xpath("//ul[@aria-label='messages']")).all(by.xpath("//span[@class='msg-list-item__date']/span[2]"));  
    return messages;
  }
  getAllActivityLogs() {
    let messages = element(by.xpath("//ul[@aria-label='activity logs']")).all(by.xpath("//dt[contains(text(),'Action Time')]//following-sibling::dd"));
    return messages;
  }
  getActionTimeActivityLogs(){
    return globalMethods.getElementByXpath("//dt[contains(text(),'Action Time')]//following-sibling::dd");
  }
  activityLogSortByRecent() {
    //return element(by.cssContainingText('.mat-option-text', 'Most Recent First'));
    return globalMethods.getElementByXpath("//option[contains(text(),'Most Recent First')]");
  }
  activityLogSortByOldest() {
    //return element(by.cssContainingText('.mat-option-text', 'Oldest First'));
    return globalMethods.getElementByXpath("//option[contains(text(),'Oldest First')]");
   
  }
  getActivityLogSubject() {
    return globalMethods.getElementByXpath("//dt[contains(text(),'Subject')]//following-sibling::dd");
  }
  getActivityLogMessageDate() {
    return globalMethods.getElementByXpath("//dt[contains(text(),'Message Date')]//following-sibling::dd");
  }
  getActivityLogActionTime() {
    return globalMethods.getElementByXpath("//dt[contains(text(),'Action Time')]//following-sibling::dd");
  }
  getActivityLogPerformedBy() {
    return globalMethods.getElementByXpath("//dt[contains(text(),'Performed By')]//following-sibling::dd");
  }
  getActivityLogActivity() {
    return globalMethods.getElementByXpath("//dt[contains(text(),'Activity')]//following-sibling::dd");
  }
  getMobileActivityLog(){
    return globalMethods.getElementById('msg_MobileActivityLog_btn');
  }
  getSendOnWarningMsgPopUp(){
    return globalMethods.getElementById('msg-warning-send_btn');
  }
  // Re-usable methods
  async clickMessagesLink(): Promise<void>{
    await globalMethods.click(await this.getMessagesLink(), 'Messages link', timeout);
  }
  async clickClose(): Promise<void>{
    await globalMethods.click(await this.getClose(), 'Close', timeout);
  }
  /**
   * clickComposeNewMessage method clicks on 'Compose New Message' button of Messages page.
   */
  async clickComposeNewMessage(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getComposeNewMessage(), true, timeout);
    await globalMethods.click(await this.getComposeNewMessage(), 'Compose New Message ', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickMessageInboxTab(): Promise<void>{
    await globalMethods.click(await this.getMessageInboxTab(), 'Message Inbox Tab', timeout);
  }
  async clickMessageSentTab(): Promise<void>{
    await globalMethods.click(await this.getMessageSentTab(), 'Message Sent Tab', timeout);
  }
  async clickSent(): Promise<void>{
    await globalMethods.click(await this.getSend(), 'Sent Button', timeout);
  }
  /**
   * clickMessageGear method clicks on 'Message gear' icon of messages page.
   */
  async clickMessageGear(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getMessageGear(), 'Message Gear', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickFirstMessagesCard(): Promise<void> {
    await globalMethods.click(await this.getFirstMessagesCard(), 'Messages Card', timeout);
  }
  async clickMessagesFirstCard(): Promise<void> {
    await globalMethods.click(await this.getFirstMessagesCard(), 'First Messages Card', timeout);
  }
  async clickReply(): Promise<void> {
    await globalMethods.click(await this.getMessageReply(), 'Reply on Message Details Page', timeout);
  }
  async clickMessageDiscardbutton(): Promise<void> {
    await globalMethods.click(await this.messageDiscardButton(), 'Discard button in Reply Message Page', timeout);
  }
  async clickMessageForward(): Promise<void> {
    await globalMethods.click(await this.messageForward(), 'Forward button on Message Details Page', timeout);
  }
  async clickMessageConnectPhysician(): Promise<void> {   
    await browser.waitForAngularEnabled(false);   
    var browserSize = await globalMethods.getConfigBrowserSize();
    await globalMethods.log("Browser Size Parameters:" + browser.params.viewport);
    //If browser width/height is a desktop viewport:
    //click connect physician
    if (browserSize === 'md' || browserSize === 'lg') {
      await globalMethods.waitForElement(await this.getMessageConnectPhysician(), true, timeout);
      await globalMethods.click(await this.getMessageConnectPhysician(), 'Connect Physician on Message Page', timeout);
      return;
    }
  //If browser size is smaller than standard viewport:
    await globalMethods.waitForElement(await this.mobileAddContact(), true, timeout);     
    await globalMethods.click(await this.mobileAddContact(), 'Connect Physician on mobile', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clicknewPCPaitentCancelConnectBtn(): Promise<void> {
    await globalMethods.click(await this.newPCPaitentCancelConnectBtn(), 'Cancel button on Connect Physician Page', timeout);
  }
  /**
   * clickActivityLog method supports both desktop and mobile. It clicks on Activity log button in messages page for mobile device.
   * For desktop, it clicks on Activity log button available under gear of messages page.
   */
  async clickActivityLog(): Promise<void> {
    await browser.waitForAngularEnabled(false);   
    var browserSize = await globalMethods.getConfigBrowserSize();
    await globalMethods.log("Browser Size Parameters:" + browser.params.viewport);
    //If browser width/height is a desktop viewport:
    //click Activity Logs outright
    if (browserSize === 'md' || browserSize === 'lg') {
      await globalMethods.waitForElement(await this.getMessageActivityLog(), true, timeout);
      await globalMethods.click(await this.getMessageActivityLog(), 'Activity Log on Gear', timeout);
      return;
    }
  //If browser size is smaller than standard viewport:   
    await globalMethods.waitForElement(await this.getMobileActivityLog(), true, timeout);     
    await globalMethods.click(await this.getMobileActivityLog(), 'Activity Log Mobile', timeout);
    await browser.waitForAngularEnabled(true);
  }   
  async clickAttachTestResults(): Promise<void> {
    await globalMethods.click(await this.messageAddAttachment(), 'Attach Test Results', timeout);
  }
  async clickTestResult(): Promise<void> {
    await globalMethods.click(await this.selectAttachTestResult(), 'Select Test Results', timeout);
  }
  async clickmessageConfirmAddAttachment(): Promise<void> {
    await globalMethods.click(await this.messageConfirmAddAttachment(), 'Attach in Attach Test Result modal', timeout);
  }
  async clickIncludeCCDA(): Promise<void> {
    await globalMethods.click(await this.getIncludeCCDA(), 'Include copy result checkbox', timeout);
  }
  async clickCancelTestResult(): Promise<void> {
    await globalMethods.click(await this.getCancelTestResult(), 'Cancel button in Attach Test Result Modal', timeout);
  }
  async clickCancelIconToField(): Promise<void> {
    await globalMethods.click(await this.getCancel(), 'Cancel icon in To field of Reply Page', timeout);
  }
  async clickMessageSubjectField(): Promise<void> {
    await globalMethods.click(await this.getMessageSubjectField(), 'Subject Field in new Message Page', timeout);
  }
  async clickMessageTextField(): Promise <void> {
    await globalMethods.click(await this.getMessageTextField(), 'Message Text Field in new Message Page', timeout);
  }
  async clicknewPCPaitentConnectBtn(): Promise<void> {
    await globalMethods.click(await this.newPCPaitentConnectBtn(), 'Connect button on Physician Connection Page', timeout);
  }
  async clickHasAttachments(): Promise<void> {
    await globalMethods.click(await this.getHasAttachments(), 'Has Attachments checkbox', timeout);
  }
  async clickResetFilter(): Promise <void> {
    await globalMethods.click(await this.messageResetFilter(), 'Reset Filter on Messages Page', timeout);
  }
  async clickDismiss(): Promise <void> {
    await globalMethods.waitForElement(await this.messageDismissButton(), true, timeout);
    await globalMethods.click(await this.messageDismissButton(), 'Dismiss on Success message popup', timeout);
  }
  async clickInboxSortBy(): Promise <void> {
    await globalMethods.click(await this.inboxBoxSortBy(), 'Sort By in Inbox of Message page', timeout);
  }
  async clickActivityLogSortBy(): Promise <void> {
    await globalMethods.click(await this.activityLogSortBy(), 'Sort By in Activity Log of Message page', timeout);
  }
   /**
   * clickMobileComposeMessage method clicks on composemessage button on mobile device
   */
  async clickMobileComposeMessage(): Promise <void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.mobileComposeMessage(), true, timeout);
    await globalMethods.click(await this.mobileComposeMessage(), 'Mobile Compose Message', timeout);
    await browser.waitForAngularEnabled(true);
  } 
  /**
   * clickSendOnWarningMessagePopup method clicks on Send button of warning popup message.
   */
  async clickSendOnWarningMessagePopup(): Promise <void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getSendOnWarningMsgPopUp(), true, timeout);
    await globalMethods.click(await this.getSendOnWarningMsgPopUp(), 'Send On Warning Message Popup', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyActivityLogs method verifies if all the activity logs are displayed in mobile and desktop view
   * @param dataFile 
   */
  async verifyActivityLogs(dataFile){    
    await browser.waitForAngularEnabled(false);   
    await globalMethods.waitForElement(await this.getActionTimeActivityLogs(), true, timeout);
    var count = await this.getAllActivityLogs().count();
    await globalMethods.log("Total Activity Logs:" + await this.getAllActivityLogs().count());   
    
    for (let i = 0; i < count; i++) {
        var activityLogDate = await this.getAllActivityLogs().get(i).getText();
        var actualActivityLogDate = await activityLogDate.trim();
        await globalMethods.log("Activity Log Date:[" + i + "]");
        await globalMethods.log("Activity Log Date from App: ="+actualActivityLogDate+"Activity Log Date from DataFile:= "+await dataFile.ActivityLogs[i].ActivityLog);
        await globalMethods.textContains(actualActivityLogDate, await dataFile.ActivityLogs[i].ActivityLog);        
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyNewMessagePageDisplay method verifies for the display of composing new messages page
   */
  async verifyNewMessagePageDisplay(){
    await browser.waitForAngularEnabled(false);
    currentUrl = await browser.getCurrentUrl();
    console.log("currentUrl"+currentUrl == ""+newMessagesPageText);
    await globalMethods.verifyTextContains(currentUrl, newMessagesPageText, true);
    await globalMethods.log("In Messages Page");
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyMessagePageDisplay method verifies for the display of messages page
   */
  async verifyMessagePageDisplay(){
    await browser.waitForAngularEnabled(false);
    //await globalMethods.waitForElement(await messages.getComposeNewMessage(), true, timeout);
    await globalMethods.waitForElement(await this.getFirstInboxMessage(), true, timeout);
    currentUrl = await browser.getCurrentUrl();
    await globalMethods.log(currentUrl);
    await globalMethods.verifyTextContains(currentUrl, messagesPageText, true);
    await browser.waitForAngularEnabled(true);
  }
}