import { browser, by, element, protractor } from 'protractor';
import * as globalMethods from 'quest-global'

let timeout=9500;
var browserSize;
let dataFile;
const FindALocationPageText = '/findlocation';
const scheduleAppointmentUrlText ='patient/confirmation';

export class Prelogin {
  navigateToHome() {
      browser.ignoreSynchronization=true;
        return browser.get('/');
      browser.ignoreSynchronization=false;
  }

  preLoginValidator() {
    return element(by.className('pl-hero__content'));
  }
  getPscSearch() {
    return element(by.id('psc-search-txt'));
  }
  getPscLocation(){
    return element(by.xpath("//span[@class='mat-option-text']"));
  }
  getPscLocationCity(){
    return globalMethods.getElementByXpath("//span[(text() = ' Wallington, NJ, USA ')]");
  }
  getPscLocationZip(){
    return globalMethods.getElementByXpath("//span[(text() = ' Mason, OH 45040, USA ')]");
  }
  getPscLocationState(){
    return globalMethods.getElementByXpath("//span[(text() = ' Ohio, USA ')]");
  }
  getPscLocationAddress(){
    return globalMethods.getElementByXpath("//span[text() =' Wallington Avenue, Wallington, NJ, USA ']");
  }
  getScheduleAnAppointment() {
    return element(by.id('mq_ScheduleAppointment_button_main'));
  }

  getPayBills() {
    return element(by.id('pl_PayBills_btn'));
  }
  getPayBillsArrowMobile() {
    return element(by.xpath("//a[@id='pay-bills']/mat-icon"));
  }
  getContactQuest() {
    return element(by.id('pl_ContactQuest_btn'));
  }

  getFaq() {
    return element(by.id('pl_FAQ_btn'));
  }

  getMessageQuest() {
    return element(by.id('pl_MessageQuest_btn'));
  }
  signInButton() {
    return element(by.id('pl_SignIn_btn'));
  }
  messageQuestFirstName() {
    return element(by.id('mq_ContactFirstName_txt'));
  }
  messageQuestLastName() {
    return element(by.id('mq_ContactLastName_txt'));
  }
  messageQuestEmail() {
    return element(by.id('mq_ContactEmail_txt'));
  }
  messageQuestConfirmEmail() {
    return element(by.id('mq_ContactConfirmEmail_txt'));
  }
  messageQuestContactReason() {
    return element(by.id('mq_ContactReason_drp'));
  }
  messageQuestContactMessage() {
    return element(by.id('mq_ContactMessage_txt'));
  }
  messageQuestSendButton() {
    return element(by.id('mq_ContactSend_btn'));
  }
  MessageQuestAccountCancellation() {
    return element(by.id('mat-option-0'));
  }

  createAccountButton() {
    return element(by.id('pl_HeroCreateAccount_btn'));
  }

  getParagraphText() {
    return element(by.css('qd-app-root')).getText();
  }

  getHeaderText() {
    return element(by.id('pl_HeaderTitle_txt'));
  }

  getSubHeaderText() {
    return element(by.id('pl_SubHeader_txt'));
  }

  getCreateAccountHeaderText() {
    return element(by.id('pl_createAccount_header'));
  }

  getCreateSubHeaderText() {
    return element(by.id('pl_createAccount_subheader'));
  }

  getWelcomeHeaderText() {
    return element(by.id('pl_welcome_header'));
  }

  getWelcomeSubHeaderText() {
    return element(by.id('pl_welcome_subheader'));
  }

  getMessageQuestForm() {
    return element(by.id('mat-dialog-title-0'));
  }

  cancelMessageQuestForm() {
    return element(by.id('mq_CancelMessageQuest_btn'));
  }

  getTimeLineFeedHeaderText() {
    return element(by.id('pl_timelinefeedheader_txt'));
  }

  getTimeLineFeedSubHeaderText() {
    return element(by.id('pl_timelinefeeddescription_txt'));
  }

  validateTimeLineFeedCards() {
    return element(by.id('pl_timelinefeed_cards'));
  }

  getNetworkHeaderText() {
    return element(by.id('pl_networkheader_txt'));
  }

  getNetworkSubHeaderText() {
    return element(by.id('pl_networkdescription_txt'));
  }

  getTestimonialsHeaderText() {
    return element(by.id('pl_testimonialsheader_txt'));
  }

  getTestimonialsSubHeaderText() {
    return element(by.id('pl_testimonialsdescription_txt'));
  }

  getTestimonialsList() {
    return element(by.id('pl_testimonialslist_list'));
  }

  getMQFirstNameField() {
    return element(by.id('mq_ContactFirstName_txt'));
  }

  getMQLastNameField() {
    return element(by.id('mq_ContactLastName_txt'));
  }

  getMQEmailField() {
    return element(by.id('mq_ContactEmail_txt'));
  }

  getMQEmailConfirmationField() {
    return element(by.id('mq_ContactConfirmEmail_txt'));
  }

  getMQReasonForContact() {
    return element(by.id('mq_ContactReason_drp'));
  }

  getMQAccountCancellation() {
    return element(by.id('mat-option-1'));
  }

  getMQAccountCreation() {
    return element(by.id('mat-option-2'));
  }

  selectMQAccountLogin() {
    return element(by.id('mat-option-3'));
  }

  selectMQAdvancedAccess() {
    return element(by.id('mat-option-4'));
  }

  selectMQHealthRecord() {
    return element(by.id('mat-option-5'));
  }

  selectMQPasswordReset() {
    return element(by.id('mat-option-6'));
  }

  selectMQPreEmployment() {
    return element(by.id('mat-option-7'));
  }

  selectMQRequestLabResults() {
    return element(by.id('mat-option-8'));
  }

  selectMQFeedback() {
    return element(by.id('mat-option-9'));
  }

  editMQMessageText() {
    return element(by.id('mq_ContactMessage_txt'));
  }

  clickMQSendButton() {
    return element(by.id('mq_ContactSend_btn'));
  }

  clickRecaptchaCheckbox() {
    return element(by.id('recaptcha-anchor'));
  }
// Added label to below three locators because part of id is changing everytime, i.e, mat-input-7, mat-input-8 etc. Since there is no other differentiating locator, using xpath with contains
  getUserName() {
    return element(by.xpath("//label[contains(text(),'Username')]"));
  }

  getPassword() {
    return element(by.xpath("//label[contains(text(),'Password')]"));
  }
  getReTypePassword() {
    return element(by.xpath("//label[contains(text(),'Re-Type Password')]"));
  }
  //Mobile Test

  getContactQuestMobile() {
    return element(by.id('contact-quest'));
  }
  getFirstLocationResult(){
    return element(by.xpath("//a[@id='psc-location-psc-locator-0']/preceding-sibling::div//div[@id='mq_FindQuestLocation_txt']"));
  }
  getSecondLocationResult(){
    return element(by.xpath("//a[@id='psc-location-psc-locator-1']/preceding-sibling::div//div[@id='mq_FindQuestLocation_txt']"));
  }
  // getFaqMobile() {
  //   //return element(by.id('faq'));
  //   return globalMethods.getElementByXpath("//a[@id='faq']");
  // }
  getFaqMobileArrow() {
    return element(by.xpath("//a[@id='faq']//mat-icon"));
  }
  getMessageQuestMobile() {
    return element(by.id('contactDialog'));
  }

  optionsMobileButton() {
    return element(by.id('options'));
  }

  getSignInMobileOptions() {
    return globalMethods.getElementById('relogin');
  }
  getSignInArrowMobileOptions() {
    return globalMethods.getElementByXpath("//button[@id='relogin']/mat-icon");
  }

  optionsMobileAppointSchedulingButton() {
    return element(by.id('appointment-scheduling'));
  }

  getPayBillsMobileOptions() {
    return element(by.id('pay-bills'));
  }

  getMobileMessageQuestForm() {
    return element(by.id('mat-dialog-title-2'));
  }

  selectHomepageScheduleAnAppointment() {
    return element(by.id('mq_ScheduleAppointment_button'));
  }
  selectFindQuestNearYou() {
    return element(by.id('psc-search-txt'));
  }
  questLocationsOptions() {
    return element(by.id('cdk-overlay-0'));
  }
  questReturnedLocations() {
    return element(by.id('mq_FindQuestLocation_txt'));
  }
  getClickHere(){
    return element(by.xpath("//a[@class='qd-contact-dialog__link']"))
  }
  getPSCLocations() {
    return globalMethods.getElementByXpath("//div[@id='mat-autocomplete-0']/mat-option");
  }
  getContactReasonAppointmentsCancel() {
    return element(by.xpath("//span[@class='mat-option-text'][contains(text(),'Appointments - cancel')]"));
  }
  getMessageQuestCancel(){
    return globalMethods.getElementById('mq_CancelMessageQuest_btn');
  }
  getMsgQuestFirstNameError(){
    return globalMethods.getElementByXpath("//input[@id='mq_ContactFirstName_txt']/../../..//mat-error");
  }
  getMsgQuestLastNameError(){
    return globalMethods.getElementByXpath("//input[@id='mq_ContactLastName_txt']/../../..//mat-error")
  }
  getMsgquestQuestEmailError(){
    return globalMethods.getElementByXpath("//input[@id='mq_ContactEmail_txt']/../../..//mat-error");
  }
  getMsgQuestConfirmEmailError(){
    return globalMethods.getElementByXpath("//input[@id='mq_ContactConfirmEmail_txt']/../../..//mat-error");
  }
  getMsgQuestMessageTextError(){
    return globalMethods.getElementByXpath("//textarea[@id='mq_ContactMessage_txt']/../../..//mat-error");
  }
  getSeeDetails(){
    return globalMethods.getElementByXpath("//mat-card[@class='mq-psc-location mat-card']/a");
  }
  getQuestionMark(){
    return globalMethods.getElementByXpath("//mat-icon[contains(text(),'help')]");
  }
  getFaqMobile() {
    return globalMethods.getElementByXpath("//a[@id='faq']");
  }
  // Setters
  /**
   * clickContactQuest method clicks on 'Contact Quest' icon of myquest home page.
   */
  async clickContactQuest(): Promise<void> {
    browserSize = await globalMethods.getConfigBrowserSize();
    await globalMethods.log("Browser Size Params:" + browser.params.viewport);
    await browser.waitForAngularEnabled(false);
    
    if (browserSize === 'md' || browserSize === 'lg') {
    await globalMethods.waitForElement(await this.getContactQuest(), true, timeout );
    await globalMethods.click(await this.getContactQuest(), 'Contact Quest', timeout);
    return;
    }
    //await globalMethods.mouseMove(await this.getContactQuestMobile(), "Contact Quest Mobile", timeout);
    await globalMethods.waitForElement(await this.getContactQuestMobile(), true, timeout );
    await globalMethods.click(await this.getContactQuestMobile(), 'Contact Quest Mobile - Prelogin', timeout);    
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickFAQ method clicks on FAQ option of myquest home page.
   */
  async clickFAQ(): Promise<void> {
    browserSize = await globalMethods.getConfigBrowserSize();
    await globalMethods.log("Browser Size Params:" + browser.params.viewport);
    await browser.waitForAngularEnabled(false);
    if (browserSize === 'md' || browserSize === 'lg') {
    await globalMethods.waitForElement(await this.getFaq(), true, timeout);
    await globalMethods.waitForVisible(await this.getFaq(), timeout);
    await globalMethods.click(await this.getFaq(), 'FAQ', timeout);
    //return;
    }
    if(browserSize === 'xs'){
      await globalMethods.waitForElement(await this.getFaqMobileArrow(), true, timeout);
      await globalMethods.waitForVisible(await this.getFaqMobileArrow(), timeout);
      await globalMethods.log("Clicking on FAQ Mobile");
      //await globalMethods.click(await this.getFaqMobileArrow(), "Faq Mobile", timeout);
      await browser.executeScript('arguments[0].click();', await this.getFaqMobileArrow());
      //return;
       
  }
    await browser.waitForAngularEnabled(true);
  }
  async clickQuestionMark(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getQuestionMark(), "Question Mark Option", timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickDashboardContactQuest(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getContactQuestMobile(), true, timeout);
    await globalMethods.mouseMove(await this.getContactQuestMobile(), "Dashboard Contact Quest", timeout);
    //await globalMethods.click(await this.getContactQuestMobile(), "Dashboard Contact Quest", timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickDashboardMessageQuest method clicks on Message Quest option of Myquest Home page.
   */
  async clickDashboardMessageQuest(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getMessageQuestMobile(), true, timeout);
    await globalMethods.click(await this.getMessageQuestMobile(), "Dashboard Message Quest", timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickMessageQuest method clicks on 'Message Quest' option of myquest home page.
   */
  async clickMessageQuest(): Promise<void> {
    browserSize = await globalMethods.getConfigBrowserSize();
    await globalMethods.log("Browser Size Params:" + browser.params.viewport);
    await browser.waitForAngularEnabled(false);
    if (browserSize === 'md' || browserSize === 'lg') {
      await globalMethods.waitForElement(await this.getMessageQuest(), true, timeout );
      await globalMethods.click(await this.getMessageQuest(), 'Message Quest', timeout);
      return;
    }
    await globalMethods.waitForElement(await this.getMessageQuestMobile(), true, timeout );
    await globalMethods.click(await this.getMessageQuestMobile(), "Message Quest Mobile", timeout);
    await browser.waitForAngularEnabled(true);
  }

  async clickPayBills(): Promise<void>{
    var browserSize = await globalMethods.getConfigBrowserSize();
        await globalMethods.log("Browser Size Parameters:" + browser.params.viewport);

        //If browser width/height is a desktop viewport:
        //click Pay Bills outright
        if (browserSize === 'md' || browserSize === 'lg') {
          await globalMethods.click(await this.getPayBills(), 'Pay Bills', timeout);
          return;
        }

        //If browser size is smaller than standard viewport:
        //two step process to click Pay Bills
        await this.getPayBillsMobileOptions();
        await globalMethods.click(await this.getPayBillsMobileOptions(), 'Pay Bills mobile', timeout);
  }

  async clickScheduleAnAppointment() : Promise<void>{
    await globalMethods.click(await this.getScheduleAnAppointment(), 'Schedule Appointment', timeout);
  }
  /**
   * clickOnClickHere method clicks on 'Click Here' of Message Quest form.
   */
  async clickOnClickHere(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getClickHere(), true, timeout );
    await globalMethods.click(await this.getClickHere(), 'Click Here', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickCloseOnMessageQuestForm method clicks on close/cancel button of message quest form.
   */
  async clickCloseOnMessageQuestForm(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getClickHere(), true, timeout );
    await globalMethods.click(await this.cancelMessageQuestForm(), 'Cancel Message Quest Form', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickSeeDetails method used to click See Details link displayed in psc location list.
   */
  async clickSeeDetails(): Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getSeeDetails(), true, timeout);
    await globalMethods.click(await this.getSeeDetails(), 'See Details', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureEnterDataInMessageQuestForm method enters data in message quest form for both valid and mandatory flows.
   * @param dataFile 
   */
  async procedureEnterDataInMessageQuestForm(dataFile){
    
    var isMandatory = dataFile.isMandatory;
    var isMaxLength = dataFile.isMaxLength;
    var isValid = dataFile.isValid;
    await browser.waitForAngularEnabled(false);
      
    if(isMandatory){
      await globalMethods.waitForElement(await this.messageQuestFirstName(), true, timeout);
      await globalMethods.sendKeys(await this.messageQuestFirstName(), protractor.Key.TAB, timeout, true);
      await globalMethods.sendKeys(await this.messageQuestLastName(), protractor.Key.TAB, timeout, true);
      await globalMethods.sendKeys(await this.messageQuestEmail(), protractor.Key.TAB, timeout, true);
      //await globalMethods.sendKeys(await this.messageQuestConfirmEmail(), protractor.Key.TAB, timeout, true);
      await this.messageQuestConfirmEmail().click();
      await this.messageQuestContactReason().click();    
      await globalMethods.waitForElement(await this.getContactReasonAppointmentsCancel(), true, timeout);
      await this.getContactReasonAppointmentsCancel().click();
      await globalMethods.sendKeys(await this.messageQuestContactMessage(), protractor.Key.TAB, timeout, true);
    } 
    if(isValid) {
    await globalMethods.waitForElement(await this.messageQuestFirstName(), true, timeout);
    await this.messageQuestFirstName().sendKeys(dataFile.firstname);    
    await this.messageQuestLastName().sendKeys(dataFile.lastname);
    await this.messageQuestEmail().sendKeys(dataFile.email);
    await this.messageQuestConfirmEmail().sendKeys(dataFile.confirmEmail);    
    await this.messageQuestContactReason().click();    
    await globalMethods.waitForElement(await this.getContactReasonAppointmentsCancel(), true, timeout);
    await this.getContactReasonAppointmentsCancel().click();
    await this.messageQuestContactMessage().sendKeys(dataFile.messageTxt);
    await globalMethods.sendKeys(await this.messageQuestContactMessage(), protractor.Key.TAB, timeout, true);
    }
    await browser.waitForAngularEnabled(true);
  }

  async procedureEnterInvalidDataInMessageQuestForm(dataFile){
    await browser.waitForAngularEnabled(false);
    // var clearFirstName = dataFile.clearFirstName;
    // var clearLastName = dataFile.clearLastName;
    // var clearEmail = dataFile.clearEmail;

    await globalMethods.clearText(await this.messageQuestFirstName(), 'first name', timeout);
    await this.messageQuestFirstName().sendKeys(dataFile.firstname);
    await globalMethods.clearText(await this.messageQuestLastName(), 'last name', timeout);
    await this.messageQuestLastName().sendKeys(dataFile.lastname);
    await globalMethods.clearText(await this.messageQuestEmail(), 'email', timeout);
    await this.messageQuestEmail().sendKeys(dataFile.email);
    await this.messageQuestConfirmEmail().sendKeys(dataFile.confirmEmail);    
    await this.messageQuestContactReason().click();
    await globalMethods.waitForElement(await this.getContactReasonAppointmentsCancel(), true, timeout);
    await this.getContactReasonAppointmentsCancel().click();       
    await this.messageQuestContactMessage().sendKeys(dataFile.messageTxt);
    await globalMethods.sendKeys(await this.messageQuestContactMessage(), protractor.Key.TAB, timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyErrorMsgOnMsgQuestForm method verifies for the display of mandatory, invalid and max length error/validation messages.
   * @param dataFile 
   */
  async verifyErrorMsgOnMsgQuestForm(dataFile){
   
    var verifyfirstname = await dataFile.verifyFirstNameErrorMsg;
    var verifylastname = await dataFile.verifyLastNameErrorMsg;
    var verifyemail = await dataFile.verifyEmailErrorMsg;
    var verifyconfirmemail = await dataFile.verifyConfirmEmailErrorMsg;
    var verifyMessageText = await dataFile.verifyMsgTextErrorMsg;
    var mandatoryFieldErrorMsg = await dataFile.mandatoryFieldValidationMsg;
    
    var firstNameMaxLengthErrorMsg = await dataFile.expectedFirstNameMaxLengthErrorMsg;
    var emailMaxLengthErrorMsg = await dataFile.expectedEmailMaxLengthErrorMsg;
    var messageTextErrorMsg = await dataFile.expectedMessageTextErrorMsg;
    var validationType = dataFile.validationType;
    await browser.waitForAngularEnabled(false);
    // getting field error messages from UI
    if (verifyfirstname) {
        await globalMethods.waitForElement(await this.getMsgQuestFirstNameError(), true, timeout);
        var actualMsgQuestFirstNameErrorMsg = await this.getMsgQuestFirstNameError().getText().then(async function (text) {
            var temp = await text.trim().toLowerCase();
            return temp;
        });
    }
    if (verifylastname) {
        await globalMethods.waitForElement(await this.getMsgQuestLastNameError(), true, timeout);
        var actualMsgQuestLastNameErrorMsg = await  this.getMsgQuestLastNameError().getText().then(async function (text) {
            var temp = await text.trim().toLowerCase();
            return temp;
        });
    }
    if (verifyemail) {
        await globalMethods.waitForElement(await this.getMsgquestQuestEmailError(), true, timeout);
        var actualMsgQuestEmailErrorMsg = await this.getMsgquestQuestEmailError().getText().then(async function (text) {
            var temp = await text.trim().toLowerCase();
            return temp;
        });
    }
    if (verifyconfirmemail) {
      await globalMethods.waitForElement(await this.getMsgQuestConfirmEmailError(), true, timeout);
      var actualConfirmEmailErrorMsg = await this.getMsgQuestConfirmEmailError().getText().then(async function (text) {
          var temp = await text.trim().toLowerCase();
          return temp;
      });
    }
    if (verifyMessageText) {
      await globalMethods.waitForElement(await this.getMsgQuestMessageTextError(), true, timeout);
      var actualMessageTextErrorMsg = await this.getMsgQuestMessageTextError().getText().then(async function (text) {
          var temp = await text.trim().toLowerCase();
          return temp;
      });
    }


    switch (validationType) {
        case 'mandatoryFields':
            await globalMethods.log("Mandatory Field Validation in Message Quest Form");
            await globalMethods.log(actualMsgQuestFirstNameErrorMsg + "==" + await mandatoryFieldErrorMsg);
            await globalMethods.verifyText(actualMsgQuestFirstNameErrorMsg, await mandatoryFieldErrorMsg, true);
            await globalMethods.log(actualMsgQuestLastNameErrorMsg + "==" + await mandatoryFieldErrorMsg);
            await globalMethods.verifyText(actualMsgQuestLastNameErrorMsg, await mandatoryFieldErrorMsg, true);
            await globalMethods.log(actualMsgQuestEmailErrorMsg + "==" + await mandatoryFieldErrorMsg);
            await globalMethods.verifyText(actualMsgQuestEmailErrorMsg, await mandatoryFieldErrorMsg, true);
            await globalMethods.log(actualConfirmEmailErrorMsg + "==" + await mandatoryFieldErrorMsg);
            await globalMethods.verifyText(actualConfirmEmailErrorMsg, await mandatoryFieldErrorMsg, true);
            await globalMethods.log(actualMessageTextErrorMsg + "==" + await mandatoryFieldErrorMsg);
            await globalMethods.verifyText(actualMessageTextErrorMsg, await mandatoryFieldErrorMsg, true);
            break;

        case 'invalidData':            
            await globalMethods.log("Invalid Data Validation in Message Quest Form");
            await globalMethods.log(actualMsgQuestFirstNameErrorMsg + "==" + dataFile.expectedFirstNameErrorMsg);
            await globalMethods.verifyText(actualMsgQuestFirstNameErrorMsg, dataFile.expectedFirstNameErrorMsg, true);
            await globalMethods.log(actualMsgQuestLastNameErrorMsg + "==" + await dataFile.expectedLastNameErrorMsg);
            await globalMethods.verifyText(actualMsgQuestLastNameErrorMsg, await dataFile.expectedLastNameErrorMsg, true);
            await globalMethods.log(actualMsgQuestEmailErrorMsg + "==" + await dataFile.expectedEmailErrorMsg);
            await globalMethods.verifyText(actualMsgQuestEmailErrorMsg, await dataFile.expectedEmailErrorMsg, true);
            await globalMethods.log(actualConfirmEmailErrorMsg + "==" + await dataFile.expectedConfirmEmailErrorMsg);
            await globalMethods.verifyText(actualConfirmEmailErrorMsg, await dataFile.expectedConfirmEmailErrorMsg, true);
            await globalMethods.log(actualMessageTextErrorMsg + "==" + await dataFile.expectedMessageTextErrorMsg);
            await globalMethods.verifyText(actualMessageTextErrorMsg, await dataFile.expectedMessageTextErrorMsg, true);
            break;
        case 'maxlengthValidation':
            await globalMethods.log(actualMsgQuestFirstNameErrorMsg + "==" + await firstNameMaxLengthErrorMsg);
            await globalMethods.verifyText(actualMsgQuestFirstNameErrorMsg, await firstNameMaxLengthErrorMsg, true);
            await globalMethods.log(actualMsgQuestEmailErrorMsg + "==" + await emailMaxLengthErrorMsg);
            await globalMethods.verifyText(actualMsgQuestEmailErrorMsg, await emailMaxLengthErrorMsg, true);
            await globalMethods.log(actualMessageTextErrorMsg + "==" + await messageTextErrorMsg);
            await globalMethods.verifyText(actualMessageTextErrorMsg, await messageTextErrorMsg, true);            
            break;
        default:
            await globalMethods.log('Message Quest Form field Validation Fail');
    }
    await browser.waitForAngularEnabled(true);
  }
  async procedureVerifyLocations(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getFirstLocationResult(), true, timeout);
    await globalMethods.verifyElement(await this.getFirstLocationResult(), timeout, true);
    await globalMethods.waitForElement(await this.getSecondLocationResult(), true, timeout);
    await globalMethods.verifyElement(await this.getSecondLocationResult(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  async procedureVerifyDefaultLocations(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.log("Verifying default locations");
    await globalMethods.waitForElement(await this.getFirstLocationResult(), true, timeout);
    await globalMethods.verifyElement(await this.getFirstLocationResult(), timeout, true);    
    await browser.waitForAngularEnabled(true);
  }
  async verifyAppointmentSchedulingArrowOnMobile(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getPayBillsArrowMobile(), true, timeout);
    await globalMethods.verifyElement(await this.getPayBillsArrowMobile(), timeout, true);
    await browser.waitForAngularEnabled(true); 
  }
  async verifySignInMobileOption(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getSignInMobileOptions(), true, timeout);
    await globalMethods.verifyElement(await this.getSignInMobileOptions(), timeout, true);
    await browser.waitForAngularEnabled(true);  
  }
  async verifySignInArrowMobileOption(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getSignInArrowMobileOptions(), true, timeout);
    await globalMethods.verifyElement(await this.getSignInArrowMobileOptions(), timeout, true);
    await browser.waitForAngularEnabled(true);  
  }
  /**
   * enterPscLocationDataInPSCSearch method enters data in psc search field on myquest home page. 
   * It waits for the auto suggestions to populate and clicks on the specified location. 
   * In case of invalid flow, it just enters invalid data in psc search field.
   * @param dataFile 
   */
  async enterPscLocationDataInPSCSearch(dataFile){
    var locationText = await dataFile.locationData;
    var isValid = dataFile.isvalid;
    var isInvalid = dataFile.isInvalid;

  await browser.waitForAngularEnabled(false);
//   if(isValid){
//     await globalMethods.clearText(await this.getPscSearch(), "psc search field", timeout);
//     //enterAndSelectFromAutoSuggest method does not work consistently. So, using below steps.
//     await globalMethods.sendKeys(await this.getPscSearch(), locationText, timeout, false);
//     await globalMethods.waitForElement(await this.getPscLocation(), true, 30000);  
//     await globalMethods.waitForClickable(await this.getPscLocation(), timeout);
//     await globalMethods.click(await this.getPscLocation(), locationText, 30000);
//  }
  if(isValid){
    await globalMethods.waitForElement(await this.getPscSearch(), true, timeout);
    await globalMethods.sendText(await this.getPscSearch(), locationText, timeout);
    //await browser.sleep(10000);
    var searchType = dataFile.searchtype;
    switch (searchType){
      case 'city':
        await globalMethods.log("Search by City");
        await globalMethods.waitForElement(await this.getPscLocationCity(), true, 20000);
        await globalMethods.click(await this.getPscLocationCity(), locationText, 30000);
        break;
      case 'zip':
        await globalMethods.log("Search by Zip Code");
        await globalMethods.waitForElement(await this.getPscLocationZip(), true, 20000);
        await globalMethods.click(await this.getPscLocationZip(), locationText, 30000);
        break;
      case 'state': 
        await globalMethods.log("Search by State");
        await globalMethods.waitForElement(await this.getPscLocationState(), true, 20000);
        await globalMethods.click(await this.getPscLocationState(), locationText, 30000);
        break;
      case 'location address':
        await globalMethods.log("Search by location address");
        await globalMethods.waitForElement(await this.getPscLocationAddress(), true, 20000);
        await globalMethods.click(await this.getPscLocationAddress(), locationText, 30000);
        break;
  }
}
 if(isInvalid){  
  await globalMethods.sendText(await this.getPscSearch(), locationText, timeout);
 }
 await browser.waitForAngularEnabled(true);
}

/**
 * verifyLocationsDisplayed method verifies the first two psc locations displayed.
 */
async verifyLocationsDisplayed(dataFile){
    var firstLocationText = await dataFile.firstLocationText;
    var secondLocationText = await dataFile.secondLocationText;
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getFirstLocationResult(), true, timeout);
    var actualFirstLocationText  = await this.getFirstLocationResult().getText().then(async function(text){
    return await text.toString().trim();
  });
  globalMethods.verifyText(actualFirstLocationText, firstLocationText, true);
    console.log(actualFirstLocationText + "==>"+ firstLocationText);
    await globalMethods.waitForElement(await this.getSecondLocationResult(), true, timeout);
    var actualSecondLocationText  = await this.getSecondLocationResult().getText().then(async function(text){
    return await text.toString().trim();
  });
    globalMethods.validateText(actualSecondLocationText, secondLocationText, true);
    console.log(actualSecondLocationText + "==>"+ secondLocationText);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyNoLocationsDisplayed method verifies that no psc locations are displayed when we enter invalid data.
   */
  async verifyNoLocationsDisplayed(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.log("Verifying locations are not displayed.");
    await globalMethods.verifyElement(await this.getPSCLocations(), timeout, false);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyFindALocationPageDisplayedInNewTab method verifies if 'find a location' page is displayed in a new page upon click of See Details 
   */
  async verifyFindALocationPageDisplayedInNewTab(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.switchTabs(1).then(async function () {
      await browser.waitForAngularEnabled(false);
      var currentUrl = await browser.getCurrentUrl();
      await globalMethods.log(currentUrl);
      await globalMethods.verifyTextContains(currentUrl, FindALocationPageText, true);
  }); 
  var handles = await browser.driver.getAllWindowHandles()
  for (let i = 1; i < handles.length; i++) {
   if (handles[i]) {
    await globalMethods.log("Closing tab: " + i + " **");
    browser.driver.switchTo().window(handles[i]);
    await globalMethods.closeTab();
   }
  }     
  await globalMethods.switchTabs(0);
  await browser.waitForAngularEnabled(true);
}

/**
 * verifyAppointmentSchedulingPage method verifies for the display of Appointment scheduling page.
 */
  async verifyAppointmentSchedulingPage(){
    await globalMethods.switchTabs(1).then(async function() {
      browser.ignoreSynchronization = true;
      var currentUrl = await browser.getCurrentUrl();
          await globalMethods.log(currentUrl);
          await globalMethods.validateTextContains(currentUrl, scheduleAppointmentUrlText, true);
    });
    var handles = await browser.driver.getAllWindowHandles()
    for (let i = 1; i < handles.length; i++) {
     if (handles[i]) {
      await globalMethods.log("Closing tabs - Appointments: " + i + " **");
      browser.driver.switchTo().window(handles[i]);
      await globalMethods.closeTab();
     }
    }     
    await globalMethods.switchTabs(0);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyPaybillsOnAppointmentSchedulingPage method verifies paybills on Appointment Scheduling page.
   */
  async verifyPaybillsOnMQHomePage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getPayBills(), true, timeout);
    await globalMethods.validateElement(await this.getPayBills(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyMessageQuestForm method verifies for the presence of an element in message quest form.
   */
  async verifyMessageQuestForm(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForVisible(await this.getMQFirstNameField(), timeout);
    await globalMethods.verifyElement(await this.getMQFirstNameField(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyAppointmentSchedulingCommentsPageInNewTab method verifies if the appointment scheduling comments page opened in new tab when clicked on Clickhere on the Message Quest Form
   */
  async verifyAppointmentSchedulingCommentsPageInNewTab(){
      await globalMethods.switchTabs(1).then(async function () {
      await browser.waitForAngularEnabled(false);
      var actualScheduledAppointmentPageText= 'contactus!appt_sched_cmt3';
      var currentUrl = await browser.getCurrentUrl();
      await globalMethods.log(currentUrl);
      await globalMethods.verifyTextContains(currentUrl, actualScheduledAppointmentPageText, true);        
      var handles = await browser.driver.getAllWindowHandles();
      for (let i = 1; i < handles.length; i++) {
      if (handles[i]) {
      await globalMethods.log("Closing appointment scheduling comments link tab: " + i + " **");
      browser.driver.switchTo().window(handles[i]);
      await globalMethods.closeTab();
      }
      }     
      await globalMethods.switchTabs(0);
      }); 
      await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureDoNotEnterDataOnMessageQuestForm method deletes the data from confirm email field.
   * @param confirmEmailLength 
   */
  async procedureDoNotEnterDataOnMessageQuestForm(confirmEmailLength){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.messageQuestFirstName(), true, timeout );
    await globalMethods.log("Confirm Email Length=>" + confirmEmailLength);
    for (let index = 0; index < confirmEmailLength; index++) {
        await globalMethods.waitForElement(await this.messageQuestConfirmEmail(), true, timeout);
        await this.messageQuestConfirmEmail().sendKeys(protractor.Key.BACK_SPACE);
    }
    await globalMethods.sendKeys(await this.messageQuestConfirmEmail(), protractor.Key.TAB, timeout, false);  
    await browser.waitForAngularEnabled(true);
  }
  /**
   * VerifySendButtonIsDisabled method verifies the disabled status of send button.
   */
  async verifySendButtonIsDisabled(){
        await browser.waitForAngularEnabled(false);
        await globalMethods.log("Verifying that send button is disabled");
        await globalMethods.verifyElement(await this.messageQuestSendButton(), timeout, true);
        var actualvalue = await this.messageQuestSendButton().isEnabled();
        await globalMethods.verifyFailOnError(actualvalue, false, "Send Button Is Disabled ",true);
        await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyCloseOnMessageQuestForm method verifies for the display of close button on Message Quest Form.
   */
  async verifyCloseOnMessageQuestForm(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.cancelMessageQuestForm(), true, timeout);
    await globalMethods.verifyElement(await this.cancelMessageQuestForm(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }  
  /**
   * verifyPrePopulatedfieldsOnMessageQuestForm method verifies if the values are prepopulated (firstname, lastname, email) on message quest form.
   * @param dataFile 
   */
  async verifyPrePopulatedfieldsOnMessageQuestForm(dataFile){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.messageQuestFirstName(), true, timeout);
    var actualFirstname = await this.messageQuestFirstName().getAttribute('value');
    await globalMethods.verifyFailOnError(actualFirstname, dataFile.firstname, "Firstname matches",true);
    var actualLastname = await this.messageQuestLastName().getAttribute('value');
    await globalMethods.verifyFailOnError(actualLastname, dataFile.lastname, "lastname matches",true);
    var actualEmail = await this.messageQuestEmail().getAttribute('value');
    await globalMethods.verifyFailOnError(actualEmail, dataFile.email, "Email matches",true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyClickhereOnMessageQuestForm method verifies for the repsence of Clickhere link on Message Quest form.
   */
  async verifyClickhereOnMessageQuestForm(){
    await globalMethods.log("Verifying for Clickhere link on Message Quest form");
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getClickHere(), true, timeout);
    await globalMethods.verifyElement(await this.getClickHere(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyDisplayOfMessageForm method verifies for an element on message quest form.
   */
  async verifyDisplayOfMessageQuestForm(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getMessageQuestCancel(), true, timeout);
    await globalMethods.verifyElement(await this.getMessageQuestCancel(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
}