import { Then, When, Given } from 'cucumber';
import { appendFile } from 'fs';
import { browser } from 'protractor';
import * as globalMethods from 'quest-global';
import { Common } from '../support/common';
import { ApiAutomated } from '../api/apiAutomated';
import { DbConnect } from '../api/dbConnect';
import { data } from 'jquery';
import * as hisOrderjson from '../../jsonfiles/hisOrder.json';
import * as female_5087AG_FBN1_EDGECASEjson from '../../jsonfiles/edgecasejsonfiles/Female_5087AG_FBN1_EDGECASE.json';
import * as hrspayloadjson from '../../jsonfiles/hrspayload.json';

let axios = require('axios');
let global = require('../global/global');
let apiAutomated = new ApiAutomated();
let dbConnect = new DbConnect();
let timeout=9500;
let apiUrl: String;
let response;
let status;
let standParentTestGuid;
let pwnOrderId;
var crypto = require('crypto');

//To get random generated name, uuid values
Given('create customer with mockdata', async()=> {
    apiUrl = "https://health-integration.gss.qa.aws.qdx.com/v2/orders";
})
When('I create a new order for that user', checkcreaterandom);
async function checkcreaterandom() {
        let guid = await apiAutomated.newGuid();
        let randomnum = await Math.floor(Math.random() * (999 - 100 + 1) + 100);      
        (hisOrderjson.adnaProcessId as string) = "TEST"+ randomnum;
        (hisOrderjson.parentTestGuid as string) = guid;
        (hisOrderjson.customer.userId as string) = guid;
        standParentTestGuid = hisOrderjson.parentTestGuid;
        console.log("*****adnaProcessId*****"+ hisOrderjson.parentTestGuid);
        response = await apiAutomated.checkPOSTStatus(apiUrl, hisOrderjson);
}
Then('I verify the order created response with status', checkOrderCreatedResponse);
async function checkOrderCreatedResponse() {
    await apiAutomated.verifyresponse(response.status, 201);   
}
Then('I get genetic review with orderId', getOrderIdgeneticreview);
async function getOrderIdgeneticreview() {
    let apiURL1 = "https://health-integration.gss.qa.aws.qdx.com/v2/orders/geneticreview?ptId="+standParentTestGuid;
    response = await apiAutomated.checkGETStatus(apiURL1); 
    pwnOrderId = response.data.orderId; 
    await apiAutomated.verifyresponse(response.status, 200)   
}
Then('I need to approve the request with PWN to get approved', getPWNOrderIdApproved);
async function getPWNOrderIdApproved() {
    response = await apiAutomated.checkGETStatus("https://health-integration.gss.qa.aws.qdx.com/testing/order/"+pwnOrderId+"/mock/approval");   
}
Then('create order with HRS with same requisition id', createOrderwithHRS);
async function createOrderwithHRS() { 
        female_5087AG_FBN1_EDGECASEjson.order.tests[38477].resultData[86025898].data.resultValue = standParentTestGuid;
        female_5087AG_FBN1_EDGECASEjson.order.requisition.id = pwnOrderId;
        var base64LabReport = await Buffer.from(JSON.stringify(female_5087AG_FBN1_EDGECASEjson)).toString('base64');        
        var md5LabReport = crypto.createHash('md5').update(JSON.stringify(female_5087AG_FBN1_EDGECASEjson)).digest('hex');
        console.log ("*****md5***** ", md5LabReport);
        (hrspayloadjson.json as string) = base64LabReport;
        (hrspayloadjson.jsonMd5 as string) = md5LabReport;
        response = await apiAutomated.checkPOSTStatus("https://health-results.gss.qa.aws.qdx.com/v1/reports",female_5087AG_FBN1_EDGECASEjson);
}