import { Navigation } from '../pages/navigation.po';
import { AccountSettings } from '../pages/account-settings.po';
import { ResetPassword } from '../pages/resetPassword.po';
import { Before, AfterAll } from 'cucumber';
import { browser } from 'protractor';
import '../global/global';
import * as globalMethods from 'quest-global';
var fs = require('fs');
var axios = require('axios');
var dns = require('dns');
var startTime, endTime, elapsedTime;
//import { Load } from '../pages/load.po';

const { BeforeAll, After, setDefaultTimeout } = require('cucumber');

const navigation: Navigation = new Navigation();
const resetPassword: ResetPassword = new ResetPassword();
const accountSettings: AccountSettings = new AccountSettings();
//let load: Load = new Load();
var global = require('../global/global');
BeforeAll({tags:"not @apiAutomated"}, async function (scenario, callback) {
    await console.log("Testing 1-2-3");
    await setDefaultTimeout(120000);
    var config = await browser.getProcessedConfig();
    var configHub = config.hub;
    if(configHub != undefined){
        let sessionId = await JSON.stringify(await browser.driver.getSession());
        await globalMethods.log("Session:" + await sessionId);
        sessionId = await sessionId.substring(1,await sessionId.length - 1);
        let url = "http://" + configHub + ":4444/grid/api/testsession?session=" + await sessionId;
        let returnResponse = await axios.get(url);
        let ip = await returnResponse.data.proxyId;
        let port = ip.substring(ip.lastIndexOf(":") + 1);
        ip = ip.substring(ip.lastIndexOf("/") + 1, ip.lastIndexOf(":"));
        await globalMethods.log("Returned node machine details: ip=" + ip + ", port=" + port);
        await dns.lookupService(await ip, await port, async function(err, result){
            await console.log("Node machine name: " + await result);
        });
    }
});
// commenting this as its not required for API
// Before({tags:"not @apiAutomated"}, async function () {
//      console.log("For each test, we have to navigate to home page, therfore removing code in step definition and placing one line here to navigate to preLogin page");
//      await navigation.navigateToHomePage();
// });
// Before({ tags: "@preLogin" }, async function () {
//     console.log("For tests that have tag as @preLogin, will always start from home page, therfore removing Given statements and placing one line here to navigate to preLogin page");
//     await navigation.navigateToHomePage();
// });

// Before({ tags: "@NewTab" }, async function () {
//     await globalMethods.log("Verifying if any other tabs are opened before execution of this scenario");
//     var handles = await browser.driver.getAllWindowHandles()
//     for (let i = 1; i < handles.length; i++) {
//      if (handles[i]) {
//       await globalMethods.log("Closing opened tabs: " + i + " **");
//       browser.driver.switchTo().window(handles[i]);
//       await globalMethods.closeTab();
//      }
//     }     
//     await globalMethods.switchTabs(0);
// });

// After({ tags: "not @preLogin and not @forgotUsername1 and not @forgotUsername and not @apiAutomated" }, async function () {
//     console.log("Clicking logout from Hooks");
//     try {

//         await navigation.clickLogout();
//     } catch (err) {
//         console.log("Cannot click logout from menu. So logging out from browser via /logout");
//         await browser.get("/logout");
//     }
//     // Below line is not working all the time when executing multiple scenarios
// });
// After({ tags: "@revoke" }, async function () {
//     // clean up
//     await navigation.clickSettingsAndBillings();
//     await navigation.clickAccountSettings();
//     await global.click(accountSettings.electronicRemoveAuth(), "revoke");
//     await global.click(accountSettings.revokeConfirmation(), "revoke confirmation");
// });
// After({ tags: "@enablePreregReq" }, async function () {
//     await browser.waitForAngularEnabled(false);
//     var isSelectedToggle = await accountSettings.getPreregistrationRequestToggleState().isSelected();
//     if (!isSelectedToggle) {
//         await accountSettings.getPreregistrationRequestToggleSlider().click().then(function () {
//             console.log('Preregistration is now enabled from hooks');
//         });
//     }
//     await browser.waitForAngularEnabled(true);
// });
// After({ tags: "@disablePreregReq" }, async function () {
//     await browser.waitForAngularEnabled(false);
//     var isSelectedToggle = await accountSettings.getPreregistrationRequestToggleState().isSelected();
//     if (isSelectedToggle) {
//         await accountSettings.getPreregistrationRequestToggleSlider().click().then(function () {
//             console.log('Preregistration is now disabled from hooks');
//         });
//     }
//     await browser.waitForAngularEnabled(true);
// });

// After({ tags: "@enableChangesMadeToYourAccount" }, async function () {
//     await browser.waitForAngularEnabled(false);
//     var isSelectedToggle = await accountSettings.getChangesMadeToYourAccountToggleState().isSelected();
//     if (!isSelectedToggle) {
//         await accountSettings.getChangesMadeToYourAccountToggleSlider().click().then(function () {
//             console.log('Changes made to your account is now enabled from hooks');
//         });
//     }
//     await browser.waitForAngularEnabled(true);
// });
// After({ tags: "@disableChangesMadeToYourAccount" }, async function () {
//     await browser.waitForAngularEnabled(false);
//     var isSelectedToggle = await accountSettings.getChangesMadeToYourAccountToggleState().isSelected();
//     if (isSelectedToggle) {
//         await accountSettings.getChangesMadeToYourAccountToggleSlider().click().then(function () {
//             console.log('Changes made to your account is now disabled from hooks');
//         });
//     }
//     await browser.waitForAngularEnabled(true);
// });

// After({ tags: "@enableAllEmail" }, async function () {
//     await browser.waitForAngularEnabled(false);
//     var isSelectedToggle = await accountSettings.getToggleAllEmailSettingsState().isSelected();
//     if (!isSelectedToggle) {
//         await accountSettings.getToggleAllEmailSettingsSlider().click().then(function () {
//             console.log('All Email is now enabled from hooks');
//         });
//     }
//     await browser.waitForAngularEnabled(true);
// });
// After({ tags: "@disableAllEmail" }, async function () {
//     await browser.waitForAngularEnabled(false);
//     var isSelectedToggle = await accountSettings.getToggleAllEmailSettingsState().isSelected();
//     if (isSelectedToggle) {
//         await accountSettings.getToggleAllEmailSettingsSlider().click().then(function () {
//             console.log('All Email is now disabled from hooks');
//         });
//     }
//     await browser.waitForAngularEnabled(true);
// });
// After({ tags: "@changePasswordInvalid" }, async function () {
//     await resetPassword.clickCancelButton();
// });

After(function(scenario,done){
    const world = this;
    //console.log("after state OBJECT:" + JSON.stringify(state));
    if (scenario.result.status === 'failed') {
        try{
            browser.takeScreenshot().then(function (stream) {
                let decodedImage = new Buffer(stream.replace(/^data:image\/(png|gif|jpeg);base64,/, ''), 'base64');
                world.attach(decodedImage, 'image/png');
                // console.log("after THIS OBJECT failed:" + JSON.stringify(world));
            }).then(function () {
                done();
            });
        }
        catch(all){
            "FAILURE: Attaching screenshot failed."
        }
    }else {
        // console.log("after THIS OBJECT:" + JSON.stringify(world));
        done();
    }
    });

    // AfterAll(async function () {
    //     let path = "C:\\code\\StarterProjectWeb\\e2e\\reports\\results\\";
    //     let directory = await fs.readdirSync(path);
    //     for (let i = 0; i < directory.length; i++) {
    //             await console.log("File:" + await directory[i]);
    //             let filename = await directory[i];
    //             let data = await fs.readFileSync(await path + await filename);
    //             // await console.log("AFTERALL File contents:" + data.toString());
    //     }
    // });