// const report = require('multiple-cucumber-html-reporter');
 
// report.generate({
//     jsonDir: '.tmp/json/',
//     reportPath: '.tmp/',
//     metadata:{
//         browser: {
//             name: 'chrome',
//             version: '60'
//         },
//         device: 'Local test machine',
//         platform: {
//             name: 'ubuntu',
//             version: '16.04'
//         }
//     },
//     customData: {
//         title: 'Run info',
//         data: [
//             {label: 'Project', value: 'Custom project'},
//             {label: 'Release', value: '1.2.3'},
//             {label: 'Cycle', value: 'B11221.34321'},
//             {label: 'Execution Start Time', value: 'Nov 19th 2017, 02:31 PM EST'},
//             {label: 'Execution End Time', value: 'Nov 19th 2017, 02:56 PM EST'}
//         ]
//     }
// });

var reporter = require('cucumber-html-reporter');
var fs = require('fs');
var options = {
        theme: 'hierarchy',
        jsonFile: './.tmp/json/echeckin.json',
        output: './.tmp/json/echeckin.html',
        //screenshotsDirectory: './e2e/reports/results/screenshots/',
        //storeScreenshots: true,
        reportSuiteAsScenarios: true,
        launchReport: false,
        ignoreBadJsonFile: false,
        name: 'Appointment Scheduler Report',
        noInlineScreenshots: false,
        // metadata is not mandatory, you can remove metadata if you like
        metadata: {
                "Test Environment": "your environment goes here",
                "Browser": "Chrome",
                "Platform": "Windows 10",
                "Executed": "on Virtual Machines"
        }
};

/**
 * Combines all results.*.json files (when there are multiple resulting from a parallel execution)
 * and writes the combined json to results.json
 * and deletes the results.*.json files
 */
async function combineResultsJson() {
        await console.log("Report combination begin")
        let jsonResponse = [];
        let path = './.tmp/json/';
        let directory = await fs.readdirSync(path);
        let multiResultJsons = false;
        for (let i = 0; i < directory.length; i++) {
                await console.log("File:" + await directory[i]);
                let filename = await directory[i];
                if (await filename.indexOf("results.") > -1 && await filename.indexOf("results.json") === -1) {
                        multiResultJsons = true;
                        let data = await fs.readFileSync(await path + await filename);
                        if(data.toString().length > 2){
                                try{
                                        let jsonData = await JSON.parse(await data.toString());
                                        jsonResponse.push(await JSON.stringify(jsonData[0]));
                                }
                                catch(error){
                                        await globalMethods.log("Error in pushing the json data.")
                                }
                        }
                        
                        fs.unlinkSync(await path + await filename);
                }
        }
        if (multiResultJsons) {
                await fs.writeFileSync('./e2e/reports/results/results.json', "[" + await jsonResponse + "]");
        }
}
async function combineResultsAndGenerateReport() {
        await combineResultsJson.call();
        await reporter.generate(options);
}

reporter.generate(options);
