var fs = require('fs');
//This will take in an array of spec files and build a multicapabilities object

//Initialize multicapabilities object
var multicapabilities = [];
//Read array passed in at runtime
//Push json object to multicapabilities object for each item in the array
//Write json object to file (in the application code directory, not starterProjectWeb directory)
function buildMulticapabilities(projectDirectory, fileNamesStr, tags, browser){
    var browserLowerCase = browser.toLowerCase();
    var fileArray = fileNamesStr.split(",");
    for(var i = 0; i < fileArray.length; i++){
        var multiCapabilitiesObject = {
            "browserName": browserLowerCase,
            "unexpectedAlertBehaviour": 'accept',
            "acceptInsecureCerts" : true,
            "chromeOptions": {
              "w3c": false,
              "prefs": {
                "profile.default_content_setting_values.geolocation":2
              }
            },
            "specs": [
              fileArray[i]
            ],
            "cucumberOpts": {
              "compiler": "ts:ts-node/register",
              "require": ["../**/*.step.ts","../support/hooks.ts"],
              "tags": [tags],
              "strict": true,
              "dry-run": false,
              "backtrace":true ,
              "format": "json:e2e/reports/results/results.json"
            }
        }
        multicapabilities.push(multiCapabilitiesObject);
    }
    fs.writeFileSync(projectDirectory + '\\multiCapabilitiesJSON.json', JSON.stringify(multicapabilities));
}
var myArgs = process.argv.slice(2);
buildMulticapabilities(myArgs[0],myArgs[1],myArgs[2],myArgs[3]);
