
var axios = require('axios');
var fs = require('fs');
var jsonData;
var testStatus;
var tag;
var passFailJSON = [];
var config;
var stringBaseUrl = 'https://questdiagnosticsinc.qacomplete.smartbear.com/rest-api/service/api/';


function readResultJSON() {
    var data = fs.readFileSync('./e2e/reports/results/results.json');
    jsonData = JSON.parse(data);
}

function buildPassFail() {
    for (var i = 0; i < jsonData.length; i++) {
        for (var j = 0; j < jsonData[i].elements.length; j++) {
            tag = "";
            var tags = jsonData[i].elements[j].tags;
            for (var k = 0; k < tags.length; k++) {
                var tagFirstDigit = tags[k].name.substring(1, 2)
                if (tagFirstDigit == '5' || tagFirstDigit == '6' || tagFirstDigit == '7' || tagFirstDigit == '8' || tagFirstDigit == '9') {
                    tag = tags[k].name.substring(1);
                    // console.log("Test case id: " + tag);
                    break;
                }
                else if (tags[k].name.indexOf('QAC') > -1){
                    tag = tags[k].name.substring(4);
                    // console.log("Test case id: " + tag);
                    break;
                }
            }
            var steps = jsonData[i].elements[j].steps;
            var stepResult = [];
            testStatus = "passed";
            for (var k = 0; k < steps.length; k++){
                if(steps[k].keyword != 'Before' && steps[k].keyword != 'After'){
                    stepResult.push(steps[k].result.status);
                    if(steps[k].result.status != "passed"){
                        testStatus = "failed";
                        break;
                    }
                }
            }
            var matchFound = false;
            for(var l = 0; l < passFailJSON.length; l++){
                if(passFailJSON[l].testCase == tag){
                    matchFound = true;
                    if(passFailJSON[l].status == "failed"){
                        break;
                    }
                    passFailJSON[l].status = testStatus;
                }
            }
            if(!matchFound){
                var jsonObj = {
                    "testCase": tag,
                    "status": testStatus
                }
                passFailJSON.push(jsonObj);
            }
        }
    }
    // console.log(JSON.stringify(passFailJSON));
    console.log("Length:" + passFailJSON.length);
}

async function authenticateQAC() {

    var usernamePassword = "taauto@questdiagnostics.com:ta_auto1";
    token = Buffer.from(usernamePassword).toString('base64');
    var stringurl = stringBaseUrl + 'v1/projects/108497';
    config = {
        headers: { "Authorization": "Basic " + token }
    };
    console.log("Config:" + config.headers.Authorization);
    try {
        const response = await axios.get(stringurl, config);
    }
    catch (error) {
        console.log("Error Response:" + error.response.data);
        return;
    }

    console.log("QAC authenticated successfully");
}

async function getTestRunItems(projectId, testRunId) {
    stringUrl = stringBaseUrl + "v2/projects/" + projectId + "/testruns/" + testRunId + "/items";
    const response = await axios.get(stringUrl, config);
    return await response.data;
}

async function pushResults(projectId, testRunId) {
    await authenticateQAC();
    var testRunItems = await getTestRunItems(projectId, testRunId);
    // await console.log(await testRunItems);
    var countUpdated = 0;
    for(var i = 0; i < passFailJSON.length; i++) {
        var testCaseNum = passFailJSON[i].testCase;
        var testRunItemId = null;
        for(var j = 0; j < await testRunItems.results.length; j++){
            if(testRunItems.results[j].test_id == await testCaseNum){
                testRunItemId = testRunItems.results[j].id;
                break;
            }
        }

        if(testRunItemId != null){
            stringUrl = stringBaseUrl + "v2/projects/" + projectId + "/testruns/" + testRunId + "/items/" + await testRunItemId;
            var status = passFailJSON[i].status.charAt(0).toUpperCase() + passFailJSON[i].status.slice(1);
            console.log("Test run item id:" + await testRunItemId + ", test: " + testCaseNum + ", status:" + status);
            var data = { status_code: status };
            
            try {
                const patchResponse = await axios.patch(await stringUrl, await data, await config);
                console.log("Updating run for QAC Test #" + testCaseNum + " succeeded...");
                countUpdated++;
            }
            catch (error) {
                console.log("Error Response:" + JSON.stringify(await error.response));
                console.log("Updating run for QAC Test #" + testCaseNum + " failed...");
            }
        
        }
    }
    console.log("Total test cases updated:" + countUpdated);
}

async function pushResultsJSONToQAC(projectId, testRunId) {
    await readResultJSON();
    await buildPassFail();
    await pushResults(projectId, testRunId);
}

var myArgs = process.argv.slice(2);
pushResultsJSONToQAC(myArgs[0], myArgs[1]);