var reporter = require('cucumber-html-reporter');
var fs = require('fs');
var options = {
        theme: 'hierarchy',
        jsonFile: './e2e/reports/results/results.json',
        output: './e2e/reports/results/report.html',
        screenshotsDirectory: './e2e/reports/results/screenshots/',
        storeScreenshots: true,
        reportSuiteAsScenarios: true,
        launchReport: false,
        ignoreBadJsonFile: false,
        name: 'Report',
        noInlineScreenshots: false,
        // metadata is not mandatory, you can remove metadata if you like
        metadata: {
                "Test Environment": "your environment goes here",
                "Browser": "Chrome",
                "Platform": "Windows 10",
                "Executed": "on Virtual Machines"
        }
};

/**
 * Combines all results.*.json files (when there are multiple resulting from a parallel execution)
 * and writes the combined json to results.json
 * and deletes the results.*.json files
 */
async function combineResultsJson() {
        await console.log("Report combination begin")
        let jsonResponse = [];
        let path = './e2e/reports/results/';
        let directory = await fs.readdirSync(path);
        let multiResultJsons = false;
        for (let i = 0; i < directory.length; i++) {
                await console.log("File:" + await directory[i]);
                let filename = await directory[i];
                await console.log("Filename:" + await filename + "\n");
                let data;
                try{
                        if(filename.indexOf(".json") > -1) data = await fs.readFileSync(await path + await filename);
                        else{continue;}
                }
                catch(e){continue;}
                let strData;
                let strJSON;
                try{
                        strData = await data.toString();
                        strJSON = await JSON.stringify(data);
                        // await console.log("File data str:" + await strData);
                        // await console.log("File json str:" + await strJSON);
                }
                catch(error){
                        await console.log("Error in printing the json string data.")
                }
                if(await filename.indexOf("results.json") > -1){
                        // await console.log("Data in results.json:" + strData);
                }
                if (await filename.indexOf("results.") > -1 && await filename.indexOf("results.json") === -1) {
                        multiResultJsons = true;
                        if(strData.length > 2){
                                try{
                                        let jsonData = await JSON.parse(strData);
                                        for(let j = 0; j < jsonData.length; j++){
                                                jsonResponse.push(await JSON.stringify(jsonData[j]));
                                        }
                                }
                                catch(error){
                                        await console.log("Error in pushing the json data.")
                                }
                        }
                        
                        fs.unlinkSync(await path + await filename);
                }
        }
        if (multiResultJsons) {
                await fs.writeFileSync('./e2e/reports/results/results.json', "[" + await jsonResponse + "]");
        }
}

const combineResultsAndGenerateReport = async () => {
        var myArgs = process.argv.slice(2);
        options.name=myArgs[0];
    
        await combineResultsJson.call();
        await reporter.generate(options);
}

module.exports = combineResultsAndGenerateReport;
